/*
 * #%L
 * JAXX :: Compiler
 * 
 * $Id: JavaParser.java 2225 2011-02-19 20:15:00Z tchemit $
 * $HeadURL: http://svn.nuiton.org/svn/jaxx/tags/jaxx-2.5.6/jaxx-compiler/src/main/java/jaxx/compiler/java/parser/JavaParser.java $
 * %%
 * Copyright (C) 2008 - 2010 CodeLutin
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation, either version 3 of the 
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Lesser Public License for more details.
 * 
 * You should have received a copy of the GNU General Lesser Public 
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/lgpl-3.0.html>.
 * #L%
 */
/* Generated By:JJTree&JavaCC: Do not edit this line. JavaParser.java */

package jaxx.compiler.java.parser;

import java.io.File;
import java.io.FileInputStream;

/**
 * Grammar to parse Java version 1.5
 *
 * @author Sreenivasa Viswanadha - Simplified and enhanced for 1.5
 */
public class JavaParser/*@bgen(jjtree)*/ implements JavaParserTreeConstants, JavaParserConstants {/*@bgen(jjtree)*/
    protected JJTJavaParserState jjtree = new JJTJavaParserState();

    /** Class to hold modifiers. */
    static public final class ModifierSet {
        /* Definitions of the bits in the modifiers field.  */
        public static final int PUBLIC = 0x0001;
        public static final int PROTECTED = 0x0002;
        public static final int PRIVATE = 0x0004;
        public static final int ABSTRACT = 0x0008;
        public static final int STATIC = 0x0010;
        public static final int FINAL = 0x0020;
        public static final int SYNCHRONIZED = 0x0040;
        public static final int NATIVE = 0x0080;
        public static final int TRANSIENT = 0x0100;
        public static final int VOLATILE = 0x0200;
        public static final int STRICTFP = 0x1000;

        /**
         * A set of accessors that indicate whether the specified modifier
         * is in the set.
         */

        public boolean isPublic(int modifiers) {
            return (modifiers & PUBLIC) != 0;
        }

        public boolean isProtected(int modifiers) {
            return (modifiers & PROTECTED) != 0;
        }

        public boolean isPrivate(int modifiers) {
            return (modifiers & PRIVATE) != 0;
        }

        public boolean isStatic(int modifiers) {
            return (modifiers & STATIC) != 0;
        }

        public boolean isAbstract(int modifiers) {
            return (modifiers & ABSTRACT) != 0;
        }

        public boolean isFinal(int modifiers) {
            return (modifiers & FINAL) != 0;
        }

        public boolean isNative(int modifiers) {
            return (modifiers & NATIVE) != 0;
        }

        public boolean isStrictfp(int modifiers) {
            return (modifiers & STRICTFP) != 0;
        }

        public boolean isSynchronized(int modifiers) {
            return (modifiers & SYNCHRONIZED) != 0;
        }

        public boolean isTransient(int modifiers) {
            return (modifiers & TRANSIENT) != 0;
        }

        public boolean isVolatile(int modifiers) {
            return (modifiers & VOLATILE) != 0;
        }

        /** Removes the given modifier. */
        static int removeModifier(int modifiers, int mod) {
            return modifiers & ~mod;
        }
    }

    public JavaParser(String fileName) {
        this(System.in);
        try {
            ReInit(new FileInputStream(new File(fileName)));
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }

    void jjtreeOpenNodeScope(Node n) {
        ((SimpleNode) n).firstToken = getToken(1);
    }

    void jjtreeCloseNodeScope(Node n) {
        ((SimpleNode) n).lastToken = getToken(0);
    }

    public SimpleNode popNode() {
        if (jjtree.nodeArity() > 0)  // number of child nodes
            return (SimpleNode) jjtree.popNode();
        else
            return null;
    }

    public static void main(String args[]) {
        JavaParser parser;
        if (args.length == 0) {
            System.out.println("Java Parser Version 1.1:  Reading from standard input . . .");
            parser = new JavaParser(System.in);
        } else if (args.length == 1) {
            System.out.println("Java Parser Version 1.1:  Reading from file " + args[0] + " . . .");
            try {
                parser = new JavaParser(new java.io.FileInputStream(args[0]));
            } catch (java.io.FileNotFoundException e) {
                System.out.println("Java Parser Version 1.1:  File " + args[0] + " not found.");
                return;
            }
        } else {
            System.out.println("Java Parser Version 1.1:  Usage is one of:");
            System.out.println("         java JavaParser < inputfile");
            System.out.println("OR");
            System.out.println("         java JavaParser inputfile");
            return;
        }
        try {
            parser.CompilationUnit();
            System.out.println("Java Parser Version 1.1:  Java program parsed successfully.");
        } catch (ParseException e) {
            System.out.println(e.getMessage());
            System.out.println("Java Parser Version 1.1:  Encountered errors during parse.");
        }
    }

    final public boolean Line() throws ParseException {
        /*@bgen(jjtree) Line */
        SimpleNode jjtn000 = new SimpleNode(JJTLINE);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        int modifiers;
        try {
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case 0:
                    jj_consume_token(0);
                    jjtree.closeNodeScope(jjtn000, true);
                    jjtc000 = false;
                    jjtreeCloseNodeScope(jjtn000);
                {
                    if (true) return true;
                }
                break;
                default:
                    if (jj_2_1(2147483647)) {
                        BlockStatement();
                        jjtree.closeNodeScope(jjtn000, true);
                        jjtc000 = false;
                        jjtreeCloseNodeScope(jjtn000);
                        {
                            if (true) return false;
                        }
                    } else if (jj_2_2(2147483647)) {
                        ClassOrInterfaceBodyDeclaration(false);
                        jjtree.closeNodeScope(jjtn000, true);
                        jjtc000 = false;
                        jjtreeCloseNodeScope(jjtn000);
                        {
                            if (true) return false;
                        }
                    } else if (jj_2_3(2147483647)) {
                        ClassOrInterfaceBodyDeclaration(false);
                        jjtree.closeNodeScope(jjtn000, true);
                        jjtc000 = false;
                        jjtreeCloseNodeScope(jjtn000);
                        {
                            if (true) return false;
                        }
                    } else if (jj_2_4(2147483647)) {
                        Expression();
                        jjtree.closeNodeScope(jjtn000, true);
                        jjtc000 = false;
                        jjtreeCloseNodeScope(jjtn000);
                        {
                            if (true) return false;
                        }
                    } else {
                        switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                            case IMPORT:
                                ImportDeclaration();
                                jjtree.closeNodeScope(jjtn000, true);
                                jjtc000 = false;
                                jjtreeCloseNodeScope(jjtn000);
                            {
                                if (true) return false;
                            }
                            break;
                            default:
                                jj_consume_token(-1);
                                throw new ParseException();
                        }
                    }
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
        throw new Error("Missing return statement in function");
    }

    /**
     * **************************************
     * THE JAVA LANGUAGE GRAMMAR STARTS HERE *
     * ***************************************
     */

/*
 * Program structuring syntax follows.
 */
    final public void CompilationUnit() throws ParseException {
        /*@bgen(jjtree) CompilationUnit */
        SimpleNode jjtn000 = new SimpleNode(JJTCOMPILATIONUNIT);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            if (jj_2_5(2147483647)) {
                PackageDeclaration();
            } else {
                ;
            }
            label_1:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case IMPORT:
                        ;
                        break;
                    default:
                        break label_1;
                }
                ImportDeclaration();
            }
            label_2:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case ABSTRACT:
                    case CLASS:
                    case ENUM:
                    case FINAL:
                    case INTERFACE:
                    case NATIVE:
                    case PRIVATE:
                    case PROTECTED:
                    case PUBLIC:
                    case STATIC:
                    case STRICTFP:
                    case SYNCHRONIZED:
                    case TRANSIENT:
                    case VOLATILE:
                    case SEMICOLON:
                    case AT:
                        ;
                        break;
                    default:
                        break label_2;
                }
                TypeDeclaration();
            }
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case 123:
                    jj_consume_token(123);
                    break;
                default:
                    ;
            }
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case STUFF_TO_IGNORE:
                    jj_consume_token(STUFF_TO_IGNORE);
                    break;
                default:
                    ;
            }
            jj_consume_token(0);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void PackageDeclaration() throws ParseException {
        /*@bgen(jjtree) PackageDeclaration */
        SimpleNode jjtn000 = new SimpleNode(JJTPACKAGEDECLARATION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            Modifiers();
            jj_consume_token(PACKAGE);
            Name();
            jj_consume_token(SEMICOLON);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void ImportDeclaration() throws ParseException {
        /*@bgen(jjtree) ImportDeclaration */
        SimpleNode jjtn000 = new SimpleNode(JJTIMPORTDECLARATION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(IMPORT);
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case STATIC:
                    jj_consume_token(STATIC);
                    break;
                default:
                    ;
            }
            Name();
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case DOT:
                    jj_consume_token(DOT);
                    jj_consume_token(STAR);
                    break;
                default:
                    ;
            }
            jj_consume_token(SEMICOLON);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    /*
    * Modifiers. We match all modifiers in a single rule to reduce the chances of
    * syntax errors for simple modifier mistakes. It will also enable us to give
    * better error messages.
    */
    final public int Modifiers() throws ParseException {
        /*@bgen(jjtree) Modifiers */
        SimpleNode jjtn000 = new SimpleNode(JJTMODIFIERS);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        int modifiers = 0;
        try {
            label_3:
            while (true) {
                if (jj_2_6(2)) {
                    ;
                } else {
                    break label_3;
                }
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case PUBLIC:
                        jj_consume_token(PUBLIC);
                        modifiers |= ModifierSet.PUBLIC;
                        break;
                    case STATIC:
                        jj_consume_token(STATIC);
                        modifiers |= ModifierSet.STATIC;
                        break;
                    case PROTECTED:
                        jj_consume_token(PROTECTED);
                        modifiers |= ModifierSet.PROTECTED;
                        break;
                    case PRIVATE:
                        jj_consume_token(PRIVATE);
                        modifiers |= ModifierSet.PRIVATE;
                        break;
                    case FINAL:
                        jj_consume_token(FINAL);
                        modifiers |= ModifierSet.FINAL;
                        break;
                    case ABSTRACT:
                        jj_consume_token(ABSTRACT);
                        modifiers |= ModifierSet.ABSTRACT;
                        break;
                    case SYNCHRONIZED:
                        jj_consume_token(SYNCHRONIZED);
                        modifiers |= ModifierSet.SYNCHRONIZED;
                        break;
                    case NATIVE:
                        jj_consume_token(NATIVE);
                        modifiers |= ModifierSet.NATIVE;
                        break;
                    case TRANSIENT:
                        jj_consume_token(TRANSIENT);
                        modifiers |= ModifierSet.TRANSIENT;
                        break;
                    case VOLATILE:
                        jj_consume_token(VOLATILE);
                        modifiers |= ModifierSet.VOLATILE;
                        break;
                    case STRICTFP:
                        jj_consume_token(STRICTFP);
                        modifiers |= ModifierSet.STRICTFP;
                        break;
                    case AT:
                        Annotation();
                        break;
                    default:
                        jj_consume_token(-1);
                        throw new ParseException();
                }
            }
            jjtree.closeNodeScope(jjtn000, true);
            jjtc000 = false;
            jjtreeCloseNodeScope(jjtn000);
            {
                if (true) return modifiers;
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
        throw new Error("Missing return statement in function");
    }

    /*
    * Declaration syntax follows.
    */
    final public void TypeDeclaration() throws ParseException {
        /*@bgen(jjtree) TypeDeclaration */
        SimpleNode jjtn000 = new SimpleNode(JJTTYPEDECLARATION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        int modifiers;
        try {
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case SEMICOLON:
                    jj_consume_token(SEMICOLON);
                    break;
                case ABSTRACT:
                case CLASS:
                case ENUM:
                case FINAL:
                case INTERFACE:
                case NATIVE:
                case PRIVATE:
                case PROTECTED:
                case PUBLIC:
                case STATIC:
                case STRICTFP:
                case SYNCHRONIZED:
                case TRANSIENT:
                case VOLATILE:
                case AT:
                    modifiers = Modifiers();
                    switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                        case CLASS:
                        case INTERFACE:
                            ClassOrInterfaceDeclaration(modifiers);
                            break;
                        case ENUM:
                            EnumDeclaration(modifiers);
                            break;
                        case AT:
                            AnnotationTypeDeclaration(modifiers);
                            break;
                        default:
                            jj_consume_token(-1);
                            throw new ParseException();
                    }
                    break;
                default:
                    jj_consume_token(-1);
                    throw new ParseException();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void ClassOrInterfaceDeclaration(int modifiers) throws ParseException {
        /*@bgen(jjtree) ClassOrInterfaceDeclaration */
        SimpleNode jjtn000 = new SimpleNode(JJTCLASSORINTERFACEDECLARATION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        boolean isInterface = false;
        try {
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case CLASS:
                    jj_consume_token(CLASS);
                    break;
                case INTERFACE:
                    jj_consume_token(INTERFACE);
                    isInterface = true;
                    break;
                default:
                    jj_consume_token(-1);
                    throw new ParseException();
            }
            jj_consume_token(IDENTIFIER);
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case LT:
                    TypeParameters();
                    break;
                default:
                    ;
            }
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case EXTENDS:
                    ExtendsList(isInterface);
                    break;
                default:
                    ;
            }
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case IMPLEMENTS:
                    ImplementsList(isInterface);
                    break;
                default:
                    ;
            }
            ClassOrInterfaceBody(isInterface);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void ExtendsList(boolean isInterface) throws ParseException {
        /*@bgen(jjtree) ExtendsList */
        SimpleNode jjtn000 = new SimpleNode(JJTEXTENDSLIST);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        boolean extendsMoreThanOne = false;
        try {
            jj_consume_token(EXTENDS);
            ClassOrInterfaceType();
            label_4:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case COMMA:
                        ;
                        break;
                    default:
                        break label_4;
                }
                jj_consume_token(COMMA);
                ClassOrInterfaceType();
                extendsMoreThanOne = true;
            }
            jjtree.closeNodeScope(jjtn000, true);
            jjtc000 = false;
            jjtreeCloseNodeScope(jjtn000);
            if (extendsMoreThanOne && !isInterface) {
                if (true)
                    throw new ParseException("A class cannot extend more than one other class");
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void ImplementsList(boolean isInterface) throws ParseException {
        /*@bgen(jjtree) ImplementsList */
        SimpleNode jjtn000 = new SimpleNode(JJTIMPLEMENTSLIST);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(IMPLEMENTS);
            ClassOrInterfaceType();
            label_5:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case COMMA:
                        ;
                        break;
                    default:
                        break label_5;
                }
                jj_consume_token(COMMA);
                ClassOrInterfaceType();
            }
            jjtree.closeNodeScope(jjtn000, true);
            jjtc000 = false;
            jjtreeCloseNodeScope(jjtn000);
            if (isInterface) {
                if (true)
                    throw new ParseException("An interface cannot implement other interfaces");
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void EnumDeclaration(int modifiers) throws ParseException {
        /*@bgen(jjtree) EnumDeclaration */
        SimpleNode jjtn000 = new SimpleNode(JJTENUMDECLARATION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(ENUM);
            jj_consume_token(IDENTIFIER);
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case IMPLEMENTS:
                    ImplementsList(false);
                    break;
                default:
                    ;
            }
            EnumBody();
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void EnumBody() throws ParseException {
        /*@bgen(jjtree) EnumBody */
        SimpleNode jjtn000 = new SimpleNode(JJTENUMBODY);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(LBRACE);
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case ABSTRACT:
                case FINAL:
                case NATIVE:
                case PRIVATE:
                case PROTECTED:
                case PUBLIC:
                case STATIC:
                case STRICTFP:
                case SYNCHRONIZED:
                case TRANSIENT:
                case VOLATILE:
                case IDENTIFIER:
                case AT:
                    EnumConstant();
                    label_6:
                    while (true) {
                        if (jj_2_7(2)) {
                            ;
                        } else {
                            break label_6;
                        }
                        jj_consume_token(COMMA);
                        EnumConstant();
                    }
                    break;
                default:
                    ;
            }
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case COMMA:
                    jj_consume_token(COMMA);
                    break;
                default:
                    ;
            }
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case SEMICOLON:
                    jj_consume_token(SEMICOLON);
                    label_7:
                    while (true) {
                        switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                            case ABSTRACT:
                            case BOOLEAN:
                            case BYTE:
                            case CHAR:
                            case CLASS:
                            case DOUBLE:
                            case ENUM:
                            case FINAL:
                            case FLOAT:
                            case INT:
                            case INTERFACE:
                            case LONG:
                            case NATIVE:
                            case PRIVATE:
                            case PROTECTED:
                            case PUBLIC:
                            case SHORT:
                            case STATIC:
                            case STRICTFP:
                            case SYNCHRONIZED:
                            case TRANSIENT:
                            case VOID:
                            case VOLATILE:
                            case IDENTIFIER:
                            case LBRACE:
                            case SEMICOLON:
                            case AT:
                            case LT:
                                ;
                                break;
                            default:
                                break label_7;
                        }
                        ClassOrInterfaceBodyDeclaration(false);
                    }
                    break;
                default:
                    ;
            }
            jj_consume_token(RBRACE);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void EnumConstant() throws ParseException {
        /*@bgen(jjtree) EnumConstant */
        SimpleNode jjtn000 = new SimpleNode(JJTENUMCONSTANT);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            Modifiers();
            jj_consume_token(IDENTIFIER);
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case LPAREN:
                    Arguments();
                    break;
                default:
                    ;
            }
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case LBRACE:
                    ClassOrInterfaceBody(false);
                    break;
                default:
                    ;
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void TypeParameters() throws ParseException {
        /*@bgen(jjtree) TypeParameters */
        SimpleNode jjtn000 = new SimpleNode(JJTTYPEPARAMETERS);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(LT);
            TypeParameter();
            label_8:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case COMMA:
                        ;
                        break;
                    default:
                        break label_8;
                }
                jj_consume_token(COMMA);
                TypeParameter();
            }
            jj_consume_token(GT);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void TypeParameter() throws ParseException {
        /*@bgen(jjtree) TypeParameter */
        SimpleNode jjtn000 = new SimpleNode(JJTTYPEPARAMETER);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(IDENTIFIER);
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case EXTENDS:
                    TypeBound();
                    break;
                default:
                    ;
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void TypeBound() throws ParseException {
        /*@bgen(jjtree) TypeBound */
        SimpleNode jjtn000 = new SimpleNode(JJTTYPEBOUND);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(EXTENDS);
            ClassOrInterfaceType();
            label_9:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case BIT_AND:
                        ;
                        break;
                    default:
                        break label_9;
                }
                jj_consume_token(BIT_AND);
                ClassOrInterfaceType();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void ClassOrInterfaceBody(boolean isInterface) throws ParseException {
        /*@bgen(jjtree) ClassOrInterfaceBody */
        SimpleNode jjtn000 = new SimpleNode(JJTCLASSORINTERFACEBODY);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(LBRACE);
            label_10:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case ABSTRACT:
                    case BOOLEAN:
                    case BYTE:
                    case CHAR:
                    case CLASS:
                    case DOUBLE:
                    case ENUM:
                    case FINAL:
                    case FLOAT:
                    case INT:
                    case INTERFACE:
                    case LONG:
                    case NATIVE:
                    case PRIVATE:
                    case PROTECTED:
                    case PUBLIC:
                    case SHORT:
                    case STATIC:
                    case STRICTFP:
                    case SYNCHRONIZED:
                    case TRANSIENT:
                    case VOID:
                    case VOLATILE:
                    case IDENTIFIER:
                    case LBRACE:
                    case SEMICOLON:
                    case AT:
                    case LT:
                        ;
                        break;
                    default:
                        break label_10;
                }
                ClassOrInterfaceBodyDeclaration(isInterface);
            }
            jj_consume_token(RBRACE);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void ClassOrInterfaceBodyDeclaration(boolean isInterface) throws ParseException {
        /*@bgen(jjtree) ClassOrInterfaceBodyDeclaration */
        SimpleNode jjtn000 = new SimpleNode(JJTCLASSORINTERFACEBODYDECLARATION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        boolean isNestedInterface = false;
        int modifiers;
        try {
            if (jj_2_10(2)) {
                Initializer();
                jjtree.closeNodeScope(jjtn000, true);
                jjtc000 = false;
                jjtreeCloseNodeScope(jjtn000);
                if (isInterface) {
                    if (true)
                        throw new ParseException("An interface cannot have initializers");
                }
            } else {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case ABSTRACT:
                    case BOOLEAN:
                    case BYTE:
                    case CHAR:
                    case CLASS:
                    case DOUBLE:
                    case ENUM:
                    case FINAL:
                    case FLOAT:
                    case INT:
                    case INTERFACE:
                    case LONG:
                    case NATIVE:
                    case PRIVATE:
                    case PROTECTED:
                    case PUBLIC:
                    case SHORT:
                    case STATIC:
                    case STRICTFP:
                    case SYNCHRONIZED:
                    case TRANSIENT:
                    case VOID:
                    case VOLATILE:
                    case IDENTIFIER:
                    case AT:
                    case LT:
                        modifiers = Modifiers();
                        switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                            case CLASS:
                            case INTERFACE:
                                ClassOrInterfaceDeclaration(modifiers);
                                break;
                            case ENUM:
                                EnumDeclaration(modifiers);
                                break;
                            default:
                                if (jj_2_8(2147483647)) {
                                    ConstructorDeclaration();
                                } else if (jj_2_9(2147483647)) {
                                    FieldDeclaration(modifiers);
                                } else {
                                    switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                                        case BOOLEAN:
                                        case BYTE:
                                        case CHAR:
                                        case DOUBLE:
                                        case FLOAT:
                                        case INT:
                                        case LONG:
                                        case SHORT:
                                        case VOID:
                                        case IDENTIFIER:
                                        case LT:
                                            MethodDeclaration(modifiers);
                                            break;
                                        default:
                                            jj_consume_token(-1);
                                            throw new ParseException();
                                    }
                                }
                        }
                        break;
                    case SEMICOLON:
                        jj_consume_token(SEMICOLON);
                        break;
                    default:
                        jj_consume_token(-1);
                        throw new ParseException();
                }
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void FieldDeclaration(int modifiers) throws ParseException {
        /*@bgen(jjtree) FieldDeclaration */
        SimpleNode jjtn000 = new SimpleNode(JJTFIELDDECLARATION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            Type();
            VariableDeclarator();
            label_11:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case COMMA:
                        ;
                        break;
                    default:
                        break label_11;
                }
                jj_consume_token(COMMA);
                VariableDeclarator();
            }
            jj_consume_token(SEMICOLON);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void VariableDeclarator() throws ParseException {
        /*@bgen(jjtree) VariableDeclarator */
        SimpleNode jjtn000 = new SimpleNode(JJTVARIABLEDECLARATOR);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            VariableDeclaratorId();
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case ASSIGN:
                    jj_consume_token(ASSIGN);
                    VariableInitializer();
                    break;
                default:
                    ;
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void VariableDeclaratorId() throws ParseException {
        /*@bgen(jjtree) VariableDeclaratorId */
        SimpleNode jjtn000 = new SimpleNode(JJTVARIABLEDECLARATORID);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(IDENTIFIER);
            label_12:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case LBRACKET:
                        ;
                        break;
                    default:
                        break label_12;
                }
                jj_consume_token(LBRACKET);
                jj_consume_token(RBRACKET);
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void VariableInitializer() throws ParseException {
        /*@bgen(jjtree) VariableInitializer */
        SimpleNode jjtn000 = new SimpleNode(JJTVARIABLEINITIALIZER);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case LBRACE:
                    ArrayInitializer();
                    break;
                case BOOLEAN:
                case BYTE:
                case CHAR:
                case DOUBLE:
                case FALSE:
                case FLOAT:
                case INT:
                case LONG:
                case NEW:
                case NULL:
                case SHORT:
                case SUPER:
                case THIS:
                case TRUE:
                case VOID:
                case INTEGER_LITERAL:
                case FLOATING_POINT_LITERAL:
                case CHARACTER_LITERAL:
                case STRING_LITERAL:
                case IDENTIFIER:
                case LPAREN:
                case BANG:
                case TILDE:
                case INCR:
                case DECR:
                case PLUS:
                case MINUS:
                    Expression();
                    break;
                default:
                    jj_consume_token(-1);
                    throw new ParseException();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void ArrayInitializer() throws ParseException {
        /*@bgen(jjtree) ArrayInitializer */
        SimpleNode jjtn000 = new SimpleNode(JJTARRAYINITIALIZER);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(LBRACE);
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case BOOLEAN:
                case BYTE:
                case CHAR:
                case DOUBLE:
                case FALSE:
                case FLOAT:
                case INT:
                case LONG:
                case NEW:
                case NULL:
                case SHORT:
                case SUPER:
                case THIS:
                case TRUE:
                case VOID:
                case INTEGER_LITERAL:
                case FLOATING_POINT_LITERAL:
                case CHARACTER_LITERAL:
                case STRING_LITERAL:
                case IDENTIFIER:
                case LPAREN:
                case LBRACE:
                case BANG:
                case TILDE:
                case INCR:
                case DECR:
                case PLUS:
                case MINUS:
                    VariableInitializer();
                    label_13:
                    while (true) {
                        if (jj_2_11(2)) {
                            ;
                        } else {
                            break label_13;
                        }
                        jj_consume_token(COMMA);
                        VariableInitializer();
                    }
                    break;
                default:
                    ;
            }
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case COMMA:
                    jj_consume_token(COMMA);
                    break;
                default:
                    ;
            }
            jj_consume_token(RBRACE);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void MethodDeclaration(int modifiers) throws ParseException {
        /*@bgen(jjtree) MethodDeclaration */
        SimpleNode jjtn000 = new SimpleNode(JJTMETHODDECLARATION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case LT:
                    TypeParameters();
                    break;
                default:
                    ;
            }
            ResultType();
            MethodDeclarator();
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case THROWS:
                    jj_consume_token(THROWS);
                    NameList();
                    break;
                default:
                    ;
            }
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case LBRACE:
                    Block();
                    break;
                case SEMICOLON:
                    jj_consume_token(SEMICOLON);
                    break;
                default:
                    jj_consume_token(-1);
                    throw new ParseException();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void MethodDeclarator() throws ParseException {
        /*@bgen(jjtree) MethodDeclarator */
        SimpleNode jjtn000 = new SimpleNode(JJTMETHODDECLARATOR);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(IDENTIFIER);
            FormalParameters();
            label_14:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case LBRACKET:
                        ;
                        break;
                    default:
                        break label_14;
                }
                jj_consume_token(LBRACKET);
                jj_consume_token(RBRACKET);
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void FormalParameters() throws ParseException {
        /*@bgen(jjtree) FormalParameters */
        SimpleNode jjtn000 = new SimpleNode(JJTFORMALPARAMETERS);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(LPAREN);
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case ABSTRACT:
                case BOOLEAN:
                case BYTE:
                case CHAR:
                case DOUBLE:
                case FINAL:
                case FLOAT:
                case INT:
                case LONG:
                case NATIVE:
                case PRIVATE:
                case PROTECTED:
                case PUBLIC:
                case SHORT:
                case STATIC:
                case STRICTFP:
                case SYNCHRONIZED:
                case TRANSIENT:
                case VOLATILE:
                case IDENTIFIER:
                case AT:
                    FormalParameter();
                    label_15:
                    while (true) {
                        switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                            case COMMA:
                                ;
                                break;
                            default:
                                break label_15;
                        }
                        jj_consume_token(COMMA);
                        FormalParameter();
                    }
                    break;
                default:
                    ;
            }
            jj_consume_token(RPAREN);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void FormalParameter() throws ParseException {
        /*@bgen(jjtree) FormalParameter */
        SimpleNode jjtn000 = new SimpleNode(JJTFORMALPARAMETER);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            Modifiers();
            Type();
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case ELLIPSIS:
                    jj_consume_token(ELLIPSIS);
                    break;
                default:
                    ;
            }
            VariableDeclaratorId();
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void ConstructorDeclaration() throws ParseException {
        /*@bgen(jjtree) ConstructorDeclaration */
        SimpleNode jjtn000 = new SimpleNode(JJTCONSTRUCTORDECLARATION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case LT:
                    TypeParameters();
                    break;
                default:
                    ;
            }
            jj_consume_token(IDENTIFIER);
            FormalParameters();
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case THROWS:
                    jj_consume_token(THROWS);
                    NameList();
                    break;
                default:
                    ;
            }
            jj_consume_token(LBRACE);
            if (jj_2_12(2147483647)) {
                ExplicitConstructorInvocation();
            } else {
                ;
            }
            label_16:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case ABSTRACT:
                    case ASSERT:
                    case BOOLEAN:
                    case BREAK:
                    case BYTE:
                    case CHAR:
                    case CLASS:
                    case CONTINUE:
                    case DO:
                    case DOUBLE:
                    case FALSE:
                    case FINAL:
                    case FLOAT:
                    case FOR:
                    case IF:
                    case INT:
                    case INTERFACE:
                    case LONG:
                    case NATIVE:
                    case NEW:
                    case NULL:
                    case PRIVATE:
                    case PROTECTED:
                    case PUBLIC:
                    case RETURN:
                    case SHORT:
                    case STATIC:
                    case STRICTFP:
                    case SUPER:
                    case SWITCH:
                    case SYNCHRONIZED:
                    case THIS:
                    case THROW:
                    case TRANSIENT:
                    case TRUE:
                    case TRY:
                    case VOID:
                    case VOLATILE:
                    case WHILE:
                    case INTEGER_LITERAL:
                    case FLOATING_POINT_LITERAL:
                    case CHARACTER_LITERAL:
                    case STRING_LITERAL:
                    case IDENTIFIER:
                    case LPAREN:
                    case LBRACE:
                    case SEMICOLON:
                    case AT:
                    case INCR:
                    case DECR:
                        ;
                        break;
                    default:
                        break label_16;
                }
                BlockStatement();
            }
            jj_consume_token(RBRACE);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void ExplicitConstructorInvocation() throws ParseException {
        /*@bgen(jjtree) ExplicitConstructorInvocation */
        SimpleNode jjtn000 = new SimpleNode(JJTEXPLICITCONSTRUCTORINVOCATION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            label_17:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case IDENTIFIER:
                        ;
                        break;
                    default:
                        break label_17;
                }
                jj_consume_token(IDENTIFIER);
                jj_consume_token(DOT);
            }
            if (jj_2_13(2)) {
                jj_consume_token(THIS);
                jj_consume_token(DOT);
            } else {
                ;
            }
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case LT:
                    TypeArguments();
                    break;
                default:
                    ;
            }
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case THIS:
                    jj_consume_token(THIS);
                    break;
                case SUPER:
                    jj_consume_token(SUPER);
                    break;
                default:
                    jj_consume_token(-1);
                    throw new ParseException();
            }
            Arguments();
            jj_consume_token(SEMICOLON);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void Initializer() throws ParseException {
        /*@bgen(jjtree) Initializer */
        SimpleNode jjtn000 = new SimpleNode(JJTINITIALIZER);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case STATIC:
                    jj_consume_token(STATIC);
                    break;
                default:
                    ;
            }
            Block();
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    /*
    * Type, name and expression syntax follows.
    */
    final public void Type() throws ParseException {
        /*@bgen(jjtree) Type */
        SimpleNode jjtn000 = new SimpleNode(JJTTYPE);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            if (jj_2_14(2)) {
                ReferenceType();
            } else {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case BOOLEAN:
                    case BYTE:
                    case CHAR:
                    case DOUBLE:
                    case FLOAT:
                    case INT:
                    case LONG:
                    case SHORT:
                        PrimitiveType();
                        break;
                    default:
                        jj_consume_token(-1);
                        throw new ParseException();
                }
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void ReferenceType() throws ParseException {
        /*@bgen(jjtree) ReferenceType */
        SimpleNode jjtn000 = new SimpleNode(JJTREFERENCETYPE);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case BOOLEAN:
                case BYTE:
                case CHAR:
                case DOUBLE:
                case FLOAT:
                case INT:
                case LONG:
                case SHORT:
                    PrimitiveType();
                    label_18:
                    while (true) {
                        jj_consume_token(LBRACKET);
                        jj_consume_token(RBRACKET);
                        if (jj_2_15(2)) {
                            ;
                        } else {
                            break label_18;
                        }
                    }
                    break;
                case IDENTIFIER:
                    ClassOrInterfaceType();
                    label_19:
                    while (true) {
                        if (jj_2_16(2)) {
                            ;
                        } else {
                            break label_19;
                        }
                        jj_consume_token(LBRACKET);
                        jj_consume_token(RBRACKET);
                    }
                    break;
                default:
                    jj_consume_token(-1);
                    throw new ParseException();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void ClassOrInterfaceType() throws ParseException {
        /*@bgen(jjtree) ClassOrInterfaceType */
        SimpleNode jjtn000 = new SimpleNode(JJTCLASSORINTERFACETYPE);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(IDENTIFIER);
            if (jj_2_17(2)) {
                TypeArguments();
            } else {
                ;
            }
            label_20:
            while (true) {
                if (jj_2_18(2)) {
                    ;
                } else {
                    break label_20;
                }
                jj_consume_token(DOT);
                jj_consume_token(IDENTIFIER);
                if (jj_2_19(2)) {
                    TypeArguments();
                } else {
                    ;
                }
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void TypeArguments() throws ParseException {
        /*@bgen(jjtree) TypeArguments */
        SimpleNode jjtn000 = new SimpleNode(JJTTYPEARGUMENTS);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(LT);
            TypeArgument();
            label_21:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case COMMA:
                        ;
                        break;
                    default:
                        break label_21;
                }
                jj_consume_token(COMMA);
                TypeArgument();
            }
            jj_consume_token(GT);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void TypeArgument() throws ParseException {
        /*@bgen(jjtree) TypeArgument */
        SimpleNode jjtn000 = new SimpleNode(JJTTYPEARGUMENT);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case BOOLEAN:
                case BYTE:
                case CHAR:
                case DOUBLE:
                case FLOAT:
                case INT:
                case LONG:
                case SHORT:
                case IDENTIFIER:
                    ReferenceType();
                    break;
                case HOOK:
                    jj_consume_token(HOOK);
                    switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                        case EXTENDS:
                        case SUPER:
                            WildcardBounds();
                            break;
                        default:
                            ;
                    }
                    break;
                default:
                    jj_consume_token(-1);
                    throw new ParseException();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void WildcardBounds() throws ParseException {
        /*@bgen(jjtree) WildcardBounds */
        SimpleNode jjtn000 = new SimpleNode(JJTWILDCARDBOUNDS);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case EXTENDS:
                    jj_consume_token(EXTENDS);
                    ReferenceType();
                    break;
                case SUPER:
                    jj_consume_token(SUPER);
                    ReferenceType();
                    break;
                default:
                    jj_consume_token(-1);
                    throw new ParseException();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void PrimitiveType() throws ParseException {
        /*@bgen(jjtree) PrimitiveType */
        SimpleNode jjtn000 = new SimpleNode(JJTPRIMITIVETYPE);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case BOOLEAN:
                    jj_consume_token(BOOLEAN);
                    break;
                case CHAR:
                    jj_consume_token(CHAR);
                    break;
                case BYTE:
                    jj_consume_token(BYTE);
                    break;
                case SHORT:
                    jj_consume_token(SHORT);
                    break;
                case INT:
                    jj_consume_token(INT);
                    break;
                case LONG:
                    jj_consume_token(LONG);
                    break;
                case FLOAT:
                    jj_consume_token(FLOAT);
                    break;
                case DOUBLE:
                    jj_consume_token(DOUBLE);
                    break;
                default:
                    jj_consume_token(-1);
                    throw new ParseException();
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void ResultType() throws ParseException {
        /*@bgen(jjtree) ResultType */
        SimpleNode jjtn000 = new SimpleNode(JJTRESULTTYPE);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case VOID:
                    jj_consume_token(VOID);
                    break;
                case BOOLEAN:
                case BYTE:
                case CHAR:
                case DOUBLE:
                case FLOAT:
                case INT:
                case LONG:
                case SHORT:
                case IDENTIFIER:
                    Type();
                    break;
                default:
                    jj_consume_token(-1);
                    throw new ParseException();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void Name() throws ParseException {
        /*@bgen(jjtree) Name */
        SimpleNode jjtn000 = new SimpleNode(JJTNAME);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(IDENTIFIER);
            label_22:
            while (true) {
                if (jj_2_20(2)) {
                    ;
                } else {
                    break label_22;
                }
                jj_consume_token(DOT);
                jj_consume_token(IDENTIFIER);
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void NameList() throws ParseException {
        /*@bgen(jjtree) NameList */
        SimpleNode jjtn000 = new SimpleNode(JJTNAMELIST);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            Name();
            label_23:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case COMMA:
                        ;
                        break;
                    default:
                        break label_23;
                }
                jj_consume_token(COMMA);
                Name();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    /*
    * Expression syntax follows.
    */
    final public void Expression() throws ParseException {
        /*@bgen(jjtree) Expression */
        SimpleNode jjtn000 = new SimpleNode(JJTEXPRESSION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            ConditionalExpression();
            if (jj_2_21(2)) {
                AssignmentOperator();
                Expression();
            } else {
                ;
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void AssignmentOperator() throws ParseException {
        /*@bgen(jjtree) AssignmentOperator */
        SimpleNode jjtn000 = new SimpleNode(JJTASSIGNMENTOPERATOR);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case ASSIGN:
                    jj_consume_token(ASSIGN);
                    break;
                case STARASSIGN:
                    jj_consume_token(STARASSIGN);
                    break;
                case SLASHASSIGN:
                    jj_consume_token(SLASHASSIGN);
                    break;
                case REMASSIGN:
                    jj_consume_token(REMASSIGN);
                    break;
                case PLUSASSIGN:
                    jj_consume_token(PLUSASSIGN);
                    break;
                case MINUSASSIGN:
                    jj_consume_token(MINUSASSIGN);
                    break;
                case LSHIFTASSIGN:
                    jj_consume_token(LSHIFTASSIGN);
                    break;
                case RSIGNEDSHIFTASSIGN:
                    jj_consume_token(RSIGNEDSHIFTASSIGN);
                    break;
                case RUNSIGNEDSHIFTASSIGN:
                    jj_consume_token(RUNSIGNEDSHIFTASSIGN);
                    break;
                case ANDASSIGN:
                    jj_consume_token(ANDASSIGN);
                    break;
                case XORASSIGN:
                    jj_consume_token(XORASSIGN);
                    break;
                case ORASSIGN:
                    jj_consume_token(ORASSIGN);
                    break;
                default:
                    jj_consume_token(-1);
                    throw new ParseException();
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void AssignmentExpression() throws ParseException {
        /*@bgen(jjtree) AssignmentExpression */
        SimpleNode jjtn000 = new SimpleNode(JJTASSIGNMENTEXPRESSION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            PrimaryExpression();
            AssignmentOperator();
            Expression();
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void ConditionalExpression() throws ParseException {
        /*@bgen(jjtree) ConditionalExpression */
        SimpleNode jjtn000 = new SimpleNode(JJTCONDITIONALEXPRESSION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            ConditionalOrExpression();
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case HOOK:
                    jj_consume_token(HOOK);
                    Expression();
                    jj_consume_token(COLON);
                    Expression();
                    break;
                default:
                    ;
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void ConditionalOrExpression() throws ParseException {
        /*@bgen(jjtree) ConditionalOrExpression */
        SimpleNode jjtn000 = new SimpleNode(JJTCONDITIONALOREXPRESSION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            ConditionalAndExpression();
            label_24:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case SC_OR:
                        ;
                        break;
                    default:
                        break label_24;
                }
                jj_consume_token(SC_OR);
                ConditionalAndExpression();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void ConditionalAndExpression() throws ParseException {
        /*@bgen(jjtree) ConditionalAndExpression */
        SimpleNode jjtn000 = new SimpleNode(JJTCONDITIONALANDEXPRESSION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            InclusiveOrExpression();
            label_25:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case SC_AND:
                        ;
                        break;
                    default:
                        break label_25;
                }
                jj_consume_token(SC_AND);
                InclusiveOrExpression();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void InclusiveOrExpression() throws ParseException {
        /*@bgen(jjtree) InclusiveOrExpression */
        SimpleNode jjtn000 = new SimpleNode(JJTINCLUSIVEOREXPRESSION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            ExclusiveOrExpression();
            label_26:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case BIT_OR:
                        ;
                        break;
                    default:
                        break label_26;
                }
                jj_consume_token(BIT_OR);
                ExclusiveOrExpression();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void ExclusiveOrExpression() throws ParseException {
        /*@bgen(jjtree) ExclusiveOrExpression */
        SimpleNode jjtn000 = new SimpleNode(JJTEXCLUSIVEOREXPRESSION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            AndExpression();
            label_27:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case XOR:
                        ;
                        break;
                    default:
                        break label_27;
                }
                jj_consume_token(XOR);
                AndExpression();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void AndExpression() throws ParseException {
        /*@bgen(jjtree) AndExpression */
        SimpleNode jjtn000 = new SimpleNode(JJTANDEXPRESSION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            EqualityExpression();
            label_28:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case BIT_AND:
                        ;
                        break;
                    default:
                        break label_28;
                }
                jj_consume_token(BIT_AND);
                EqualityExpression();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void EqualityExpression() throws ParseException {
        /*@bgen(jjtree) EqualityExpression */
        SimpleNode jjtn000 = new SimpleNode(JJTEQUALITYEXPRESSION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            InstanceOfExpression();
            label_29:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case EQ:
                    case NE:
                        ;
                        break;
                    default:
                        break label_29;
                }
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case EQ:
                        jj_consume_token(EQ);
                        break;
                    case NE:
                        jj_consume_token(NE);
                        break;
                    default:
                        jj_consume_token(-1);
                        throw new ParseException();
                }
                InstanceOfExpression();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void InstanceOfExpression() throws ParseException {
        /*@bgen(jjtree) InstanceOfExpression */
        SimpleNode jjtn000 = new SimpleNode(JJTINSTANCEOFEXPRESSION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            RelationalExpression();
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case INSTANCEOF:
                    jj_consume_token(INSTANCEOF);
                    Type();
                    break;
                default:
                    ;
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void RelationalExpression() throws ParseException {
        /*@bgen(jjtree) RelationalExpression */
        SimpleNode jjtn000 = new SimpleNode(JJTRELATIONALEXPRESSION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            ShiftExpression();
            label_30:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case LT:
                    case LE:
                    case GE:
                    case GT:
                        ;
                        break;
                    default:
                        break label_30;
                }
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case LT:
                        jj_consume_token(LT);
                        break;
                    case GT:
                        jj_consume_token(GT);
                        break;
                    case LE:
                        jj_consume_token(LE);
                        break;
                    case GE:
                        jj_consume_token(GE);
                        break;
                    default:
                        jj_consume_token(-1);
                        throw new ParseException();
                }
                ShiftExpression();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void ShiftExpression() throws ParseException {
        /*@bgen(jjtree) ShiftExpression */
        SimpleNode jjtn000 = new SimpleNode(JJTSHIFTEXPRESSION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            AdditiveExpression();
            label_31:
            while (true) {
                if (jj_2_22(1)) {
                    ;
                } else {
                    break label_31;
                }
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case LSHIFT:
                        jj_consume_token(LSHIFT);
                        break;
                    default:
                        if (jj_2_23(1)) {
                            RSIGNEDSHIFT();
                        } else if (jj_2_24(1)) {
                            RUNSIGNEDSHIFT();
                        } else {
                            jj_consume_token(-1);
                            throw new ParseException();
                        }
                }
                AdditiveExpression();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void AdditiveExpression() throws ParseException {
        /*@bgen(jjtree) AdditiveExpression */
        SimpleNode jjtn000 = new SimpleNode(JJTADDITIVEEXPRESSION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            MultiplicativeExpression();
            label_32:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case PLUS:
                    case MINUS:
                        ;
                        break;
                    default:
                        break label_32;
                }
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case PLUS:
                        jj_consume_token(PLUS);
                        break;
                    case MINUS:
                        jj_consume_token(MINUS);
                        break;
                    default:
                        jj_consume_token(-1);
                        throw new ParseException();
                }
                MultiplicativeExpression();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void MultiplicativeExpression() throws ParseException {
        /*@bgen(jjtree) MultiplicativeExpression */
        SimpleNode jjtn000 = new SimpleNode(JJTMULTIPLICATIVEEXPRESSION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            UnaryExpression();
            label_33:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case STAR:
                    case SLASH:
                    case REM:
                        ;
                        break;
                    default:
                        break label_33;
                }
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case STAR:
                        jj_consume_token(STAR);
                        break;
                    case SLASH:
                        jj_consume_token(SLASH);
                        break;
                    case REM:
                        jj_consume_token(REM);
                        break;
                    default:
                        jj_consume_token(-1);
                        throw new ParseException();
                }
                UnaryExpression();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void UnaryExpression() throws ParseException {
        /*@bgen(jjtree) UnaryExpression */
        SimpleNode jjtn000 = new SimpleNode(JJTUNARYEXPRESSION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case PLUS:
                case MINUS:
                    switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                        case PLUS:
                            jj_consume_token(PLUS);
                            break;
                        case MINUS:
                            jj_consume_token(MINUS);
                            break;
                        default:
                            jj_consume_token(-1);
                            throw new ParseException();
                    }
                    UnaryExpression();
                    break;
                case INCR:
                    PreIncrementExpression();
                    break;
                case DECR:
                    PreDecrementExpression();
                    break;
                case BOOLEAN:
                case BYTE:
                case CHAR:
                case DOUBLE:
                case FALSE:
                case FLOAT:
                case INT:
                case LONG:
                case NEW:
                case NULL:
                case SHORT:
                case SUPER:
                case THIS:
                case TRUE:
                case VOID:
                case INTEGER_LITERAL:
                case FLOATING_POINT_LITERAL:
                case CHARACTER_LITERAL:
                case STRING_LITERAL:
                case IDENTIFIER:
                case LPAREN:
                case BANG:
                case TILDE:
                    UnaryExpressionNotPlusMinus();
                    break;
                default:
                    jj_consume_token(-1);
                    throw new ParseException();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void PreIncrementExpression() throws ParseException {
        /*@bgen(jjtree) PreIncrementExpression */
        SimpleNode jjtn000 = new SimpleNode(JJTPREINCREMENTEXPRESSION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(INCR);
            PrimaryExpression();
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void PreDecrementExpression() throws ParseException {
        /*@bgen(jjtree) PreDecrementExpression */
        SimpleNode jjtn000 = new SimpleNode(JJTPREDECREMENTEXPRESSION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(DECR);
            PrimaryExpression();
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void UnaryExpressionNotPlusMinus() throws ParseException {
        /*@bgen(jjtree) UnaryExpressionNotPlusMinus */
        SimpleNode jjtn000 = new SimpleNode(JJTUNARYEXPRESSIONNOTPLUSMINUS);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case BANG:
                case TILDE:
                    switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                        case TILDE:
                            jj_consume_token(TILDE);
                            break;
                        case BANG:
                            jj_consume_token(BANG);
                            break;
                        default:
                            jj_consume_token(-1);
                            throw new ParseException();
                    }
                    UnaryExpression();
                    break;
                default:
                    if (jj_2_25(2147483647)) {
                        CastExpression();
                    } else {
                        switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                            case BOOLEAN:
                            case BYTE:
                            case CHAR:
                            case DOUBLE:
                            case FALSE:
                            case FLOAT:
                            case INT:
                            case LONG:
                            case NEW:
                            case NULL:
                            case SHORT:
                            case SUPER:
                            case THIS:
                            case TRUE:
                            case VOID:
                            case INTEGER_LITERAL:
                            case FLOATING_POINT_LITERAL:
                            case CHARACTER_LITERAL:
                            case STRING_LITERAL:
                            case IDENTIFIER:
                            case LPAREN:
                                PostfixExpression();
                                break;
                            default:
                                jj_consume_token(-1);
                                throw new ParseException();
                        }
                    }
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

// This production is to determine lookahead only.  The LOOKAHEAD specifications
// below are not used, but they are there just to indicate that we know about

    // this.
    final public void CastLookahead() throws ParseException {
        /*@bgen(jjtree) CastLookahead */
        SimpleNode jjtn000 = new SimpleNode(JJTCASTLOOKAHEAD);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            if (jj_2_26(2)) {
                jj_consume_token(LPAREN);
                PrimitiveType();
            } else if (jj_2_27(2147483647)) {
                jj_consume_token(LPAREN);
                Type();
                jj_consume_token(LBRACKET);
                jj_consume_token(RBRACKET);
            } else {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case LPAREN:
                        jj_consume_token(LPAREN);
                        Type();
                        jj_consume_token(RPAREN);
                        switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                            case TILDE:
                                jj_consume_token(TILDE);
                                break;
                            case BANG:
                                jj_consume_token(BANG);
                                break;
                            case LPAREN:
                                jj_consume_token(LPAREN);
                                break;
                            case IDENTIFIER:
                                jj_consume_token(IDENTIFIER);
                                break;
                            case THIS:
                                jj_consume_token(THIS);
                                break;
                            case SUPER:
                                jj_consume_token(SUPER);
                                break;
                            case NEW:
                                jj_consume_token(NEW);
                                break;
                            case FALSE:
                            case NULL:
                            case TRUE:
                            case INTEGER_LITERAL:
                            case FLOATING_POINT_LITERAL:
                            case CHARACTER_LITERAL:
                            case STRING_LITERAL:
                                Literal();
                                break;
                            default:
                                jj_consume_token(-1);
                                throw new ParseException();
                        }
                        break;
                    default:
                        jj_consume_token(-1);
                        throw new ParseException();
                }
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void PostfixExpression() throws ParseException {
        /*@bgen(jjtree) PostfixExpression */
        SimpleNode jjtn000 = new SimpleNode(JJTPOSTFIXEXPRESSION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            PrimaryExpression();
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case INCR:
                case DECR:
                    PostfixOperator();
                    break;
                default:
                    ;
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void PostfixOperator() throws ParseException {
        /*@bgen(jjtree) PostfixOperator */
        SimpleNode jjtn000 = new SimpleNode(JJTPOSTFIXOPERATOR);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case INCR:
                    jj_consume_token(INCR);
                    break;
                case DECR:
                    jj_consume_token(DECR);
                    break;
                default:
                    jj_consume_token(-1);
                    throw new ParseException();
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void CastExpression() throws ParseException {
        /*@bgen(jjtree) CastExpression */
        SimpleNode jjtn000 = new SimpleNode(JJTCASTEXPRESSION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            if (jj_2_28(2147483647)) {
                jj_consume_token(LPAREN);
                Type();
                jj_consume_token(RPAREN);
                UnaryExpression();
            } else {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case LPAREN:
                        jj_consume_token(LPAREN);
                        Type();
                        jj_consume_token(RPAREN);
                        UnaryExpressionNotPlusMinus();
                        break;
                    default:
                        jj_consume_token(-1);
                        throw new ParseException();
                }
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void PrimaryExpression() throws ParseException {
        /*@bgen(jjtree) PrimaryExpression */
        SimpleNode jjtn000 = new SimpleNode(JJTPRIMARYEXPRESSION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            PrimaryPrefix();
            label_34:
            while (true) {
                if (jj_2_29(2)) {
                    ;
                } else {
                    break label_34;
                }
                PrimarySuffix();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void MemberSelector() throws ParseException {
        /*@bgen(jjtree) MemberSelector */
        SimpleNode jjtn000 = new SimpleNode(JJTMEMBERSELECTOR);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(DOT);
            TypeArguments();
            jj_consume_token(IDENTIFIER);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void PrimaryPrefix() throws ParseException {
        /*@bgen(jjtree) PrimaryPrefix */
        SimpleNode jjtn000 = new SimpleNode(JJTPRIMARYPREFIX);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case FALSE:
                case NULL:
                case TRUE:
                case INTEGER_LITERAL:
                case FLOATING_POINT_LITERAL:
                case CHARACTER_LITERAL:
                case STRING_LITERAL:
                    Literal();
                    break;
                default:
                    if (jj_2_30(2147483647)) {
                        label_35:
                        while (true) {
                            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                                case IDENTIFIER:
                                    ;
                                    break;
                                default:
                                    break label_35;
                            }
                            jj_consume_token(IDENTIFIER);
                            jj_consume_token(DOT);
                        }
                        jj_consume_token(THIS);
                    } else {
                        switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                            case SUPER:
                                jj_consume_token(SUPER);
                                jj_consume_token(DOT);
                                jj_consume_token(IDENTIFIER);
                                break;
                            case LPAREN:
                                jj_consume_token(LPAREN);
                                Expression();
                                jj_consume_token(RPAREN);
                                break;
                            case NEW:
                                AllocationExpression();
                                break;
                            default:
                                if (jj_2_31(2147483647)) {
                                    ResultType();
                                    jj_consume_token(DOT);
                                    jj_consume_token(CLASS);
                                } else {
                                    switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                                        case IDENTIFIER:
                                            Name();
                                            break;
                                        default:
                                            jj_consume_token(-1);
                                            throw new ParseException();
                                    }
                                }
                        }
                    }
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void PrimarySuffix() throws ParseException {
        /*@bgen(jjtree) PrimarySuffix */
        SimpleNode jjtn000 = new SimpleNode(JJTPRIMARYSUFFIX);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            if (jj_2_32(2147483647)) {
                jj_consume_token(DOT);
                jj_consume_token(SUPER);
            } else if (jj_2_33(2147483647)) {
                jj_consume_token(DOT);
                jj_consume_token(THIS);
            } else if (jj_2_34(2)) {
                jj_consume_token(DOT);
                AllocationExpression();
            } else if (jj_2_35(3)) {
                MemberSelector();
            } else {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case LBRACKET:
                        jj_consume_token(LBRACKET);
                        Expression();
                        jj_consume_token(RBRACKET);
                        break;
                    case DOT:
                        jj_consume_token(DOT);
                        jj_consume_token(IDENTIFIER);
                        break;
                    case LPAREN:
                        Arguments();
                        break;
                    default:
                        jj_consume_token(-1);
                        throw new ParseException();
                }
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void Literal() throws ParseException {
        /*@bgen(jjtree) Literal */
        SimpleNode jjtn000 = new SimpleNode(JJTLITERAL);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case INTEGER_LITERAL:
                    jj_consume_token(INTEGER_LITERAL);
                    break;
                case FLOATING_POINT_LITERAL:
                    jj_consume_token(FLOATING_POINT_LITERAL);
                    break;
                case CHARACTER_LITERAL:
                    jj_consume_token(CHARACTER_LITERAL);
                    break;
                case STRING_LITERAL:
                    jj_consume_token(STRING_LITERAL);
                    break;
                case FALSE:
                case TRUE:
                    BooleanLiteral();
                    break;
                case NULL:
                    NullLiteral();
                    break;
                default:
                    jj_consume_token(-1);
                    throw new ParseException();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void BooleanLiteral() throws ParseException {
        /*@bgen(jjtree) BooleanLiteral */
        SimpleNode jjtn000 = new SimpleNode(JJTBOOLEANLITERAL);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case TRUE:
                    jj_consume_token(TRUE);
                    break;
                case FALSE:
                    jj_consume_token(FALSE);
                    break;
                default:
                    jj_consume_token(-1);
                    throw new ParseException();
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void NullLiteral() throws ParseException {
        /*@bgen(jjtree) NullLiteral */
        SimpleNode jjtn000 = new SimpleNode(JJTNULLLITERAL);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(NULL);
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void Arguments() throws ParseException {
        /*@bgen(jjtree) Arguments */
        SimpleNode jjtn000 = new SimpleNode(JJTARGUMENTS);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(LPAREN);
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case BOOLEAN:
                case BYTE:
                case CHAR:
                case DOUBLE:
                case FALSE:
                case FLOAT:
                case INT:
                case LONG:
                case NEW:
                case NULL:
                case SHORT:
                case SUPER:
                case THIS:
                case TRUE:
                case VOID:
                case INTEGER_LITERAL:
                case FLOATING_POINT_LITERAL:
                case CHARACTER_LITERAL:
                case STRING_LITERAL:
                case IDENTIFIER:
                case LPAREN:
                case BANG:
                case TILDE:
                case INCR:
                case DECR:
                case PLUS:
                case MINUS:
                    ArgumentList();
                    break;
                default:
                    ;
            }
            jj_consume_token(RPAREN);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void ArgumentList() throws ParseException {
        /*@bgen(jjtree) ArgumentList */
        SimpleNode jjtn000 = new SimpleNode(JJTARGUMENTLIST);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            Expression();
            label_36:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case COMMA:
                        ;
                        break;
                    default:
                        break label_36;
                }
                jj_consume_token(COMMA);
                Expression();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void AllocationExpression() throws ParseException {
        /*@bgen(jjtree) AllocationExpression */
        SimpleNode jjtn000 = new SimpleNode(JJTALLOCATIONEXPRESSION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            if (jj_2_36(2)) {
                jj_consume_token(NEW);
                PrimitiveType();
                ArrayDimsAndInits();
            } else {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case NEW:
                        jj_consume_token(NEW);
                        ClassOrInterfaceType();
                        switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                            case LT:
                                TypeArguments();
                                break;
                            default:
                                ;
                        }
                        switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                            case LBRACKET:
                                ArrayDimsAndInits();
                                break;
                            case LPAREN:
                                Arguments();
                                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                                    case LBRACE:
                                        ClassOrInterfaceBody(false);
                                        break;
                                    default:
                                        ;
                                }
                                break;
                            default:
                                jj_consume_token(-1);
                                throw new ParseException();
                        }
                        break;
                    default:
                        jj_consume_token(-1);
                        throw new ParseException();
                }
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    /*
    * The third LOOKAHEAD specification below is to parse to PrimarySuffix
    * if there is an expression between the "[...]".
    */
    final public void ArrayDimsAndInits() throws ParseException {
        /*@bgen(jjtree) ArrayDimsAndInits */
        SimpleNode jjtn000 = new SimpleNode(JJTARRAYDIMSANDINITS);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            if (jj_2_39(2)) {
                label_37:
                while (true) {
                    jj_consume_token(LBRACKET);
                    Expression();
                    jj_consume_token(RBRACKET);
                    if (jj_2_37(2)) {
                        ;
                    } else {
                        break label_37;
                    }
                }
                label_38:
                while (true) {
                    if (jj_2_38(2)) {
                        ;
                    } else {
                        break label_38;
                    }
                    jj_consume_token(LBRACKET);
                    jj_consume_token(RBRACKET);
                }
            } else {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case LBRACKET:
                        label_39:
                        while (true) {
                            jj_consume_token(LBRACKET);
                            jj_consume_token(RBRACKET);
                            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                                case LBRACKET:
                                    ;
                                    break;
                                default:
                                    break label_39;
                            }
                        }
                        ArrayInitializer();
                        break;
                    default:
                        jj_consume_token(-1);
                        throw new ParseException();
                }
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    /*
    * Statement syntax follows.
    */
    final public void Statement() throws ParseException {
        /*@bgen(jjtree) Statement */
        SimpleNode jjtn000 = new SimpleNode(JJTSTATEMENT);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            if (jj_2_40(2)) {
                LabeledStatement();
            } else {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case ASSERT:
                        AssertStatement();
                        break;
                    case LBRACE:
                        Block();
                        break;
                    case SEMICOLON:
                        EmptyStatement();
                        break;
                    case BOOLEAN:
                    case BYTE:
                    case CHAR:
                    case DOUBLE:
                    case FALSE:
                    case FLOAT:
                    case INT:
                    case LONG:
                    case NEW:
                    case NULL:
                    case SHORT:
                    case SUPER:
                    case THIS:
                    case TRUE:
                    case VOID:
                    case INTEGER_LITERAL:
                    case FLOATING_POINT_LITERAL:
                    case CHARACTER_LITERAL:
                    case STRING_LITERAL:
                    case IDENTIFIER:
                    case LPAREN:
                    case INCR:
                    case DECR:
                        StatementExpression();
                        jj_consume_token(SEMICOLON);
                        break;
                    case SWITCH:
                        SwitchStatement();
                        break;
                    case IF:
                        IfStatement();
                        break;
                    case WHILE:
                        WhileStatement();
                        break;
                    case DO:
                        DoStatement();
                        break;
                    case FOR:
                        ForStatement();
                        break;
                    case BREAK:
                        BreakStatement();
                        break;
                    case CONTINUE:
                        ContinueStatement();
                        break;
                    case RETURN:
                        ReturnStatement();
                        break;
                    case THROW:
                        ThrowStatement();
                        break;
                    case SYNCHRONIZED:
                        SynchronizedStatement();
                        break;
                    case TRY:
                        TryStatement();
                        break;
                    default:
                        jj_consume_token(-1);
                        throw new ParseException();
                }
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void AssertStatement() throws ParseException {
        /*@bgen(jjtree) AssertStatement */
        SimpleNode jjtn000 = new SimpleNode(JJTASSERTSTATEMENT);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(ASSERT);
            Expression();
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case COLON:
                    jj_consume_token(COLON);
                    Expression();
                    break;
                default:
                    ;
            }
            jj_consume_token(SEMICOLON);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void LabeledStatement() throws ParseException {
        /*@bgen(jjtree) LabeledStatement */
        SimpleNode jjtn000 = new SimpleNode(JJTLABELEDSTATEMENT);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(IDENTIFIER);
            jj_consume_token(COLON);
            Statement();
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void Block() throws ParseException {
        /*@bgen(jjtree) Block */
        SimpleNode jjtn000 = new SimpleNode(JJTBLOCK);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(LBRACE);
            label_40:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case ABSTRACT:
                    case ASSERT:
                    case BOOLEAN:
                    case BREAK:
                    case BYTE:
                    case CHAR:
                    case CLASS:
                    case CONTINUE:
                    case DO:
                    case DOUBLE:
                    case FALSE:
                    case FINAL:
                    case FLOAT:
                    case FOR:
                    case IF:
                    case INT:
                    case INTERFACE:
                    case LONG:
                    case NATIVE:
                    case NEW:
                    case NULL:
                    case PRIVATE:
                    case PROTECTED:
                    case PUBLIC:
                    case RETURN:
                    case SHORT:
                    case STATIC:
                    case STRICTFP:
                    case SUPER:
                    case SWITCH:
                    case SYNCHRONIZED:
                    case THIS:
                    case THROW:
                    case TRANSIENT:
                    case TRUE:
                    case TRY:
                    case VOID:
                    case VOLATILE:
                    case WHILE:
                    case INTEGER_LITERAL:
                    case FLOATING_POINT_LITERAL:
                    case CHARACTER_LITERAL:
                    case STRING_LITERAL:
                    case IDENTIFIER:
                    case LPAREN:
                    case LBRACE:
                    case SEMICOLON:
                    case AT:
                    case INCR:
                    case DECR:
                        ;
                        break;
                    default:
                        break label_40;
                }
                BlockStatement();
            }
            jj_consume_token(RBRACE);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void BlockStatement() throws ParseException {
        /*@bgen(jjtree) BlockStatement */
        SimpleNode jjtn000 = new SimpleNode(JJTBLOCKSTATEMENT);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            if (jj_2_41(2147483647)) {
                LocalVariableDeclaration();
                jj_consume_token(SEMICOLON);
            } else {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case ASSERT:
                    case BOOLEAN:
                    case BREAK:
                    case BYTE:
                    case CHAR:
                    case CONTINUE:
                    case DO:
                    case DOUBLE:
                    case FALSE:
                    case FLOAT:
                    case FOR:
                    case IF:
                    case INT:
                    case LONG:
                    case NEW:
                    case NULL:
                    case RETURN:
                    case SHORT:
                    case SUPER:
                    case SWITCH:
                    case SYNCHRONIZED:
                    case THIS:
                    case THROW:
                    case TRUE:
                    case TRY:
                    case VOID:
                    case WHILE:
                    case INTEGER_LITERAL:
                    case FLOATING_POINT_LITERAL:
                    case CHARACTER_LITERAL:
                    case STRING_LITERAL:
                    case IDENTIFIER:
                    case LPAREN:
                    case LBRACE:
                    case SEMICOLON:
                    case INCR:
                    case DECR:
                        Statement();
                        break;
                    case CLASS:
                    case INTERFACE:
                        ClassOrInterfaceDeclaration(0);
                        break;
                    default:
                        jj_consume_token(-1);
                        throw new ParseException();
                }
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void LocalVariableDeclaration() throws ParseException {
        /*@bgen(jjtree) LocalVariableDeclaration */
        SimpleNode jjtn000 = new SimpleNode(JJTLOCALVARIABLEDECLARATION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            Modifiers();
            Type();
            VariableDeclarator();
            label_41:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case COMMA:
                        ;
                        break;
                    default:
                        break label_41;
                }
                jj_consume_token(COMMA);
                VariableDeclarator();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void EmptyStatement() throws ParseException {
        /*@bgen(jjtree) EmptyStatement */
        SimpleNode jjtn000 = new SimpleNode(JJTEMPTYSTATEMENT);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(SEMICOLON);
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void StatementExpression() throws ParseException {
        /*@bgen(jjtree) StatementExpression */
        SimpleNode jjtn000 = new SimpleNode(JJTSTATEMENTEXPRESSION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case INCR:
                    PreIncrementExpression();
                    break;
                case DECR:
                    PreDecrementExpression();
                    break;
                default:
                    if (jj_2_42(2147483647)) {
                        AssignmentExpression();
                    } else {
                        switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                            case BOOLEAN:
                            case BYTE:
                            case CHAR:
                            case DOUBLE:
                            case FALSE:
                            case FLOAT:
                            case INT:
                            case LONG:
                            case NEW:
                            case NULL:
                            case SHORT:
                            case SUPER:
                            case THIS:
                            case TRUE:
                            case VOID:
                            case INTEGER_LITERAL:
                            case FLOATING_POINT_LITERAL:
                            case CHARACTER_LITERAL:
                            case STRING_LITERAL:
                            case IDENTIFIER:
                            case LPAREN:
                                PostfixExpression();
                                break;
                            default:
                                jj_consume_token(-1);
                                throw new ParseException();
                        }
                    }
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void SwitchStatement() throws ParseException {
        /*@bgen(jjtree) SwitchStatement */
        SimpleNode jjtn000 = new SimpleNode(JJTSWITCHSTATEMENT);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(SWITCH);
            jj_consume_token(LPAREN);
            Expression();
            jj_consume_token(RPAREN);
            jj_consume_token(LBRACE);
            label_42:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case CASE:
                    case _DEFAULT:
                        ;
                        break;
                    default:
                        break label_42;
                }
                SwitchLabel();
                label_43:
                while (true) {
                    switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                        case ABSTRACT:
                        case ASSERT:
                        case BOOLEAN:
                        case BREAK:
                        case BYTE:
                        case CHAR:
                        case CLASS:
                        case CONTINUE:
                        case DO:
                        case DOUBLE:
                        case FALSE:
                        case FINAL:
                        case FLOAT:
                        case FOR:
                        case IF:
                        case INT:
                        case INTERFACE:
                        case LONG:
                        case NATIVE:
                        case NEW:
                        case NULL:
                        case PRIVATE:
                        case PROTECTED:
                        case PUBLIC:
                        case RETURN:
                        case SHORT:
                        case STATIC:
                        case STRICTFP:
                        case SUPER:
                        case SWITCH:
                        case SYNCHRONIZED:
                        case THIS:
                        case THROW:
                        case TRANSIENT:
                        case TRUE:
                        case TRY:
                        case VOID:
                        case VOLATILE:
                        case WHILE:
                        case INTEGER_LITERAL:
                        case FLOATING_POINT_LITERAL:
                        case CHARACTER_LITERAL:
                        case STRING_LITERAL:
                        case IDENTIFIER:
                        case LPAREN:
                        case LBRACE:
                        case SEMICOLON:
                        case AT:
                        case INCR:
                        case DECR:
                            ;
                            break;
                        default:
                            break label_43;
                    }
                    BlockStatement();
                }
            }
            jj_consume_token(RBRACE);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void SwitchLabel() throws ParseException {
        /*@bgen(jjtree) SwitchLabel */
        SimpleNode jjtn000 = new SimpleNode(JJTSWITCHLABEL);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case CASE:
                    jj_consume_token(CASE);
                    Expression();
                    jj_consume_token(COLON);
                    break;
                case _DEFAULT:
                    jj_consume_token(_DEFAULT);
                    jj_consume_token(COLON);
                    break;
                default:
                    jj_consume_token(-1);
                    throw new ParseException();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void IfStatement() throws ParseException {
        /*@bgen(jjtree) IfStatement */
        SimpleNode jjtn000 = new SimpleNode(JJTIFSTATEMENT);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(IF);
            jj_consume_token(LPAREN);
            Expression();
            jj_consume_token(RPAREN);
            Statement();
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case ELSE:
                    jj_consume_token(ELSE);
                    Statement();
                    break;
                default:
                    ;
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void WhileStatement() throws ParseException {
        /*@bgen(jjtree) WhileStatement */
        SimpleNode jjtn000 = new SimpleNode(JJTWHILESTATEMENT);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(WHILE);
            jj_consume_token(LPAREN);
            Expression();
            jj_consume_token(RPAREN);
            Statement();
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void DoStatement() throws ParseException {
        /*@bgen(jjtree) DoStatement */
        SimpleNode jjtn000 = new SimpleNode(JJTDOSTATEMENT);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(DO);
            Statement();
            jj_consume_token(WHILE);
            jj_consume_token(LPAREN);
            Expression();
            jj_consume_token(RPAREN);
            jj_consume_token(SEMICOLON);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void ForStatement() throws ParseException {
        /*@bgen(jjtree) ForStatement */
        SimpleNode jjtn000 = new SimpleNode(JJTFORSTATEMENT);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(FOR);
            jj_consume_token(LPAREN);
            if (jj_2_43(2147483647)) {
                Modifiers();
                Type();
                jj_consume_token(IDENTIFIER);
                jj_consume_token(COLON);
                Expression();
            } else {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case ABSTRACT:
                    case BOOLEAN:
                    case BYTE:
                    case CHAR:
                    case DOUBLE:
                    case FALSE:
                    case FINAL:
                    case FLOAT:
                    case INT:
                    case LONG:
                    case NATIVE:
                    case NEW:
                    case NULL:
                    case PRIVATE:
                    case PROTECTED:
                    case PUBLIC:
                    case SHORT:
                    case STATIC:
                    case STRICTFP:
                    case SUPER:
                    case SYNCHRONIZED:
                    case THIS:
                    case TRANSIENT:
                    case TRUE:
                    case VOID:
                    case VOLATILE:
                    case INTEGER_LITERAL:
                    case FLOATING_POINT_LITERAL:
                    case CHARACTER_LITERAL:
                    case STRING_LITERAL:
                    case IDENTIFIER:
                    case LPAREN:
                    case SEMICOLON:
                    case AT:
                    case INCR:
                    case DECR:
                        switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                            case ABSTRACT:
                            case BOOLEAN:
                            case BYTE:
                            case CHAR:
                            case DOUBLE:
                            case FALSE:
                            case FINAL:
                            case FLOAT:
                            case INT:
                            case LONG:
                            case NATIVE:
                            case NEW:
                            case NULL:
                            case PRIVATE:
                            case PROTECTED:
                            case PUBLIC:
                            case SHORT:
                            case STATIC:
                            case STRICTFP:
                            case SUPER:
                            case SYNCHRONIZED:
                            case THIS:
                            case TRANSIENT:
                            case TRUE:
                            case VOID:
                            case VOLATILE:
                            case INTEGER_LITERAL:
                            case FLOATING_POINT_LITERAL:
                            case CHARACTER_LITERAL:
                            case STRING_LITERAL:
                            case IDENTIFIER:
                            case LPAREN:
                            case AT:
                            case INCR:
                            case DECR:
                                ForInit();
                                break;
                            default:
                                ;
                        }
                        jj_consume_token(SEMICOLON);
                        switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                            case BOOLEAN:
                            case BYTE:
                            case CHAR:
                            case DOUBLE:
                            case FALSE:
                            case FLOAT:
                            case INT:
                            case LONG:
                            case NEW:
                            case NULL:
                            case SHORT:
                            case SUPER:
                            case THIS:
                            case TRUE:
                            case VOID:
                            case INTEGER_LITERAL:
                            case FLOATING_POINT_LITERAL:
                            case CHARACTER_LITERAL:
                            case STRING_LITERAL:
                            case IDENTIFIER:
                            case LPAREN:
                            case BANG:
                            case TILDE:
                            case INCR:
                            case DECR:
                            case PLUS:
                            case MINUS:
                                Expression();
                                break;
                            default:
                                ;
                        }
                        jj_consume_token(SEMICOLON);
                        switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                            case BOOLEAN:
                            case BYTE:
                            case CHAR:
                            case DOUBLE:
                            case FALSE:
                            case FLOAT:
                            case INT:
                            case LONG:
                            case NEW:
                            case NULL:
                            case SHORT:
                            case SUPER:
                            case THIS:
                            case TRUE:
                            case VOID:
                            case INTEGER_LITERAL:
                            case FLOATING_POINT_LITERAL:
                            case CHARACTER_LITERAL:
                            case STRING_LITERAL:
                            case IDENTIFIER:
                            case LPAREN:
                            case INCR:
                            case DECR:
                                ForUpdate();
                                break;
                            default:
                                ;
                        }
                        break;
                    default:
                        jj_consume_token(-1);
                        throw new ParseException();
                }
            }
            jj_consume_token(RPAREN);
            Statement();
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void ForInit() throws ParseException {
        /*@bgen(jjtree) ForInit */
        SimpleNode jjtn000 = new SimpleNode(JJTFORINIT);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            if (jj_2_44(2147483647)) {
                LocalVariableDeclaration();
            } else {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case BOOLEAN:
                    case BYTE:
                    case CHAR:
                    case DOUBLE:
                    case FALSE:
                    case FLOAT:
                    case INT:
                    case LONG:
                    case NEW:
                    case NULL:
                    case SHORT:
                    case SUPER:
                    case THIS:
                    case TRUE:
                    case VOID:
                    case INTEGER_LITERAL:
                    case FLOATING_POINT_LITERAL:
                    case CHARACTER_LITERAL:
                    case STRING_LITERAL:
                    case IDENTIFIER:
                    case LPAREN:
                    case INCR:
                    case DECR:
                        StatementExpressionList();
                        break;
                    default:
                        jj_consume_token(-1);
                        throw new ParseException();
                }
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void StatementExpressionList() throws ParseException {
        /*@bgen(jjtree) StatementExpressionList */
        SimpleNode jjtn000 = new SimpleNode(JJTSTATEMENTEXPRESSIONLIST);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            StatementExpression();
            label_44:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case COMMA:
                        ;
                        break;
                    default:
                        break label_44;
                }
                jj_consume_token(COMMA);
                StatementExpression();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void ForUpdate() throws ParseException {
        /*@bgen(jjtree) ForUpdate */
        SimpleNode jjtn000 = new SimpleNode(JJTFORUPDATE);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            StatementExpressionList();
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void BreakStatement() throws ParseException {
        /*@bgen(jjtree) BreakStatement */
        SimpleNode jjtn000 = new SimpleNode(JJTBREAKSTATEMENT);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(BREAK);
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case IDENTIFIER:
                    jj_consume_token(IDENTIFIER);
                    break;
                default:
                    ;
            }
            jj_consume_token(SEMICOLON);
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void ContinueStatement() throws ParseException {
        /*@bgen(jjtree) ContinueStatement */
        SimpleNode jjtn000 = new SimpleNode(JJTCONTINUESTATEMENT);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(CONTINUE);
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case IDENTIFIER:
                    jj_consume_token(IDENTIFIER);
                    break;
                default:
                    ;
            }
            jj_consume_token(SEMICOLON);
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void ReturnStatement() throws ParseException {
        /*@bgen(jjtree) ReturnStatement */
        SimpleNode jjtn000 = new SimpleNode(JJTRETURNSTATEMENT);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(RETURN);
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case BOOLEAN:
                case BYTE:
                case CHAR:
                case DOUBLE:
                case FALSE:
                case FLOAT:
                case INT:
                case LONG:
                case NEW:
                case NULL:
                case SHORT:
                case SUPER:
                case THIS:
                case TRUE:
                case VOID:
                case INTEGER_LITERAL:
                case FLOATING_POINT_LITERAL:
                case CHARACTER_LITERAL:
                case STRING_LITERAL:
                case IDENTIFIER:
                case LPAREN:
                case BANG:
                case TILDE:
                case INCR:
                case DECR:
                case PLUS:
                case MINUS:
                    Expression();
                    break;
                default:
                    ;
            }
            jj_consume_token(SEMICOLON);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void ThrowStatement() throws ParseException {
        /*@bgen(jjtree) ThrowStatement */
        SimpleNode jjtn000 = new SimpleNode(JJTTHROWSTATEMENT);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(THROW);
            Expression();
            jj_consume_token(SEMICOLON);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void SynchronizedStatement() throws ParseException {
        /*@bgen(jjtree) SynchronizedStatement */
        SimpleNode jjtn000 = new SimpleNode(JJTSYNCHRONIZEDSTATEMENT);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(SYNCHRONIZED);
            jj_consume_token(LPAREN);
            Expression();
            jj_consume_token(RPAREN);
            Block();
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void TryStatement() throws ParseException {
        /*@bgen(jjtree) TryStatement */
        SimpleNode jjtn000 = new SimpleNode(JJTTRYSTATEMENT);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(TRY);
            Block();
            label_45:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case CATCH:
                        ;
                        break;
                    default:
                        break label_45;
                }
                jj_consume_token(CATCH);
                jj_consume_token(LPAREN);
                FormalParameter();
                jj_consume_token(RPAREN);
                Block();
            }
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case FINALLY:
                    jj_consume_token(FINALLY);
                    Block();
                    break;
                default:
                    ;
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    /* We use productions to match >>>, >> and > so that we can keep the
    * type declaration syntax with generics clean
    */
    final public void RUNSIGNEDSHIFT() throws ParseException {
        /*@bgen(jjtree) RUNSIGNEDSHIFT */
        SimpleNode jjtn000 = new SimpleNode(JJTRUNSIGNEDSHIFT);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            if (getToken(1).kind == GT &&
                    ((Token.GTToken) getToken(1)).realKind == RUNSIGNEDSHIFT) {

            } else {
                jj_consume_token(-1);
                throw new ParseException();
            }
            jj_consume_token(GT);
            jj_consume_token(GT);
            jj_consume_token(GT);
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void RSIGNEDSHIFT() throws ParseException {
        /*@bgen(jjtree) RSIGNEDSHIFT */
        SimpleNode jjtn000 = new SimpleNode(JJTRSIGNEDSHIFT);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            if (getToken(1).kind == GT &&
                    ((Token.GTToken) getToken(1)).realKind == RSIGNEDSHIFT) {

            } else {
                jj_consume_token(-1);
                throw new ParseException();
            }
            jj_consume_token(GT);
            jj_consume_token(GT);
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    /* Annotation syntax follows. */
    final public void Annotation() throws ParseException {
        /*@bgen(jjtree) Annotation */
        SimpleNode jjtn000 = new SimpleNode(JJTANNOTATION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            if (jj_2_45(2147483647)) {
                NormalAnnotation();
            } else if (jj_2_46(2147483647)) {
                SingleMemberAnnotation();
            } else {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case AT:
                        MarkerAnnotation();
                        break;
                    default:
                        jj_consume_token(-1);
                        throw new ParseException();
                }
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void NormalAnnotation() throws ParseException {
        /*@bgen(jjtree) NormalAnnotation */
        SimpleNode jjtn000 = new SimpleNode(JJTNORMALANNOTATION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(AT);
            Name();
            jj_consume_token(LPAREN);
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case IDENTIFIER:
                    MemberValuePairs();
                    break;
                default:
                    ;
            }
            jj_consume_token(RPAREN);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void MarkerAnnotation() throws ParseException {
        /*@bgen(jjtree) MarkerAnnotation */
        SimpleNode jjtn000 = new SimpleNode(JJTMARKERANNOTATION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(AT);
            Name();
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void SingleMemberAnnotation() throws ParseException {
        /*@bgen(jjtree) SingleMemberAnnotation */
        SimpleNode jjtn000 = new SimpleNode(JJTSINGLEMEMBERANNOTATION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(AT);
            Name();
            jj_consume_token(LPAREN);
            MemberValue();
            jj_consume_token(RPAREN);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void MemberValuePairs() throws ParseException {
        /*@bgen(jjtree) MemberValuePairs */
        SimpleNode jjtn000 = new SimpleNode(JJTMEMBERVALUEPAIRS);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            MemberValuePair();
            label_46:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case COMMA:
                        ;
                        break;
                    default:
                        break label_46;
                }
                jj_consume_token(COMMA);
                MemberValuePair();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void MemberValuePair() throws ParseException {
        /*@bgen(jjtree) MemberValuePair */
        SimpleNode jjtn000 = new SimpleNode(JJTMEMBERVALUEPAIR);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(IDENTIFIER);
            jj_consume_token(ASSIGN);
            MemberValue();
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void MemberValue() throws ParseException {
        /*@bgen(jjtree) MemberValue */
        SimpleNode jjtn000 = new SimpleNode(JJTMEMBERVALUE);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case AT:
                    Annotation();
                    break;
                case LBRACE:
                    MemberValueArrayInitializer();
                    break;
                case BOOLEAN:
                case BYTE:
                case CHAR:
                case DOUBLE:
                case FALSE:
                case FLOAT:
                case INT:
                case LONG:
                case NEW:
                case NULL:
                case SHORT:
                case SUPER:
                case THIS:
                case TRUE:
                case VOID:
                case INTEGER_LITERAL:
                case FLOATING_POINT_LITERAL:
                case CHARACTER_LITERAL:
                case STRING_LITERAL:
                case IDENTIFIER:
                case LPAREN:
                case BANG:
                case TILDE:
                case INCR:
                case DECR:
                case PLUS:
                case MINUS:
                    ConditionalExpression();
                    break;
                default:
                    jj_consume_token(-1);
                    throw new ParseException();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void MemberValueArrayInitializer() throws ParseException {
        /*@bgen(jjtree) MemberValueArrayInitializer */
        SimpleNode jjtn000 = new SimpleNode(JJTMEMBERVALUEARRAYINITIALIZER);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(LBRACE);
            MemberValue();
            label_47:
            while (true) {
                if (jj_2_47(2)) {
                    ;
                } else {
                    break label_47;
                }
                jj_consume_token(COMMA);
                MemberValue();
            }
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case COMMA:
                    jj_consume_token(COMMA);
                    break;
                default:
                    ;
            }
            jj_consume_token(RBRACE);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    /* Annotation Types. */
    final public void AnnotationTypeDeclaration(int modifiers) throws ParseException {
        /*@bgen(jjtree) AnnotationTypeDeclaration */
        SimpleNode jjtn000 = new SimpleNode(JJTANNOTATIONTYPEDECLARATION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(AT);
            jj_consume_token(INTERFACE);
            jj_consume_token(IDENTIFIER);
            AnnotationTypeBody();
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void AnnotationTypeBody() throws ParseException {
        /*@bgen(jjtree) AnnotationTypeBody */
        SimpleNode jjtn000 = new SimpleNode(JJTANNOTATIONTYPEBODY);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(LBRACE);
            label_48:
            while (true) {
                switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                    case ABSTRACT:
                    case BOOLEAN:
                    case BYTE:
                    case CHAR:
                    case CLASS:
                    case DOUBLE:
                    case ENUM:
                    case FINAL:
                    case FLOAT:
                    case INT:
                    case INTERFACE:
                    case LONG:
                    case NATIVE:
                    case PRIVATE:
                    case PROTECTED:
                    case PUBLIC:
                    case SHORT:
                    case STATIC:
                    case STRICTFP:
                    case SYNCHRONIZED:
                    case TRANSIENT:
                    case VOLATILE:
                    case IDENTIFIER:
                    case SEMICOLON:
                    case AT:
                        ;
                        break;
                    default:
                        break label_48;
                }
                AnnotationTypeMemberDeclaration();
            }
            jj_consume_token(RBRACE);
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void AnnotationTypeMemberDeclaration() throws ParseException {
        /*@bgen(jjtree) AnnotationTypeMemberDeclaration */
        SimpleNode jjtn000 = new SimpleNode(JJTANNOTATIONTYPEMEMBERDECLARATION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        int modifiers;
        try {
            switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                case ABSTRACT:
                case BOOLEAN:
                case BYTE:
                case CHAR:
                case CLASS:
                case DOUBLE:
                case ENUM:
                case FINAL:
                case FLOAT:
                case INT:
                case INTERFACE:
                case LONG:
                case NATIVE:
                case PRIVATE:
                case PROTECTED:
                case PUBLIC:
                case SHORT:
                case STATIC:
                case STRICTFP:
                case SYNCHRONIZED:
                case TRANSIENT:
                case VOLATILE:
                case IDENTIFIER:
                case AT:
                    modifiers = Modifiers();
                    if (jj_2_48(2147483647)) {
                        Type();
                        jj_consume_token(IDENTIFIER);
                        jj_consume_token(LPAREN);
                        jj_consume_token(RPAREN);
                        switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                            case _DEFAULT:
                                DefaultValue();
                                break;
                            default:
                                ;
                        }
                        jj_consume_token(SEMICOLON);
                    } else {
                        switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
                            case CLASS:
                            case INTERFACE:
                                ClassOrInterfaceDeclaration(modifiers);
                                break;
                            case ENUM:
                                EnumDeclaration(modifiers);
                                break;
                            case AT:
                                AnnotationTypeDeclaration(modifiers);
                                break;
                            case BOOLEAN:
                            case BYTE:
                            case CHAR:
                            case DOUBLE:
                            case FLOAT:
                            case INT:
                            case LONG:
                            case SHORT:
                            case IDENTIFIER:
                                FieldDeclaration(modifiers);
                                break;
                            default:
                                jj_consume_token(-1);
                                throw new ParseException();
                        }
                    }
                    break;
                case SEMICOLON:
                    jj_consume_token(SEMICOLON);
                    break;
                default:
                    jj_consume_token(-1);
                    throw new ParseException();
            }
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final public void DefaultValue() throws ParseException {
        /*@bgen(jjtree) DefaultValue */
        SimpleNode jjtn000 = new SimpleNode(JJTDEFAULTVALUE);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);
        jjtreeOpenNodeScope(jjtn000);
        try {
            jj_consume_token(_DEFAULT);
            MemberValue();
        } catch (Throwable jjte000) {
            if (jjtc000) {
                jjtree.clearNodeScope(jjtn000);
                jjtc000 = false;
            } else {
                jjtree.popNode();
            }
            if (jjte000 instanceof RuntimeException) {
                {
                    if (true) throw (RuntimeException) jjte000;
                }
            }
            if (jjte000 instanceof ParseException) {
                {
                    if (true) throw (ParseException) jjte000;
                }
            }
            {
                if (true) throw (Error) jjte000;
            }
        } finally {
            if (jjtc000) {
                jjtree.closeNodeScope(jjtn000, true);
                jjtreeCloseNodeScope(jjtn000);
            }
        }
    }

    final private boolean jj_2_1(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_1();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_2(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_2();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_3(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_3();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_4(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_4();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_5(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_5();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_6(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_6();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_7(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_7();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_8(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_8();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_9(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_9();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_10(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_10();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_11(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_11();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_12(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_12();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_13(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_13();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_14(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_14();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_15(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_15();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_16(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_16();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_17(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_17();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_18(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_18();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_19(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_19();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_20(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_20();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_21(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_21();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_22(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_22();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_23(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_23();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_24(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_24();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_25(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_25();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_26(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_26();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_27(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_27();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_28(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_28();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_29(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_29();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_30(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_30();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_31(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_31();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_32(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_32();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_33(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_33();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_34(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_34();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_35(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_35();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_36(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_36();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_37(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_37();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_38(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_38();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_39(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_39();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_40(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_40();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_41(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_41();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_42(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_42();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_43(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_43();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_44(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_44();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_45(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_45();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_46(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_46();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_47(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_47();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_2_48(int xla) {
        jj_la = xla;
        jj_lastpos = jj_scanpos = token;
        try {
            return !jj_3_48();
        }
        catch (LookaheadSuccess ls) {
            return true;
        }
    }

    final private boolean jj_3R_56() {
        if (jj_3R_101()) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3_21()) jj_scanpos = xsp;
        return false;
    }

    final private boolean jj_3R_135() {
        if (jj_scan_token(COMMA)) return true;
        if (jj_3R_91()) return true;
        return false;
    }

    final private boolean jj_3R_99() {
        if (jj_3R_91()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_135()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3_20() {
        if (jj_scan_token(DOT)) return true;
        if (jj_scan_token(IDENTIFIER)) return true;
        return false;
    }

    final private boolean jj_3R_91() {
        if (jj_scan_token(IDENTIFIER)) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3_20()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_122() {
        if (jj_3R_72()) return true;
        return false;
    }

    final private boolean jj_3R_86() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_scan_token(58)) {
            jj_scanpos = xsp;
            if (jj_3R_122()) return true;
        }
        return false;
    }

    final private boolean jj_3_19() {
        if (jj_3R_78()) return true;
        return false;
    }

    final private boolean jj_3R_83() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_scan_token(10)) {
            jj_scanpos = xsp;
            if (jj_scan_token(15)) {
                jj_scanpos = xsp;
                if (jj_scan_token(12)) {
                    jj_scanpos = xsp;
                    if (jj_scan_token(46)) {
                        jj_scanpos = xsp;
                        if (jj_scan_token(35)) {
                            jj_scanpos = xsp;
                            if (jj_scan_token(37)) {
                                jj_scanpos = xsp;
                                if (jj_scan_token(28)) {
                                    jj_scanpos = xsp;
                                    if (jj_scan_token(21)) return true;
                                }
                            }
                        }
                    }
                }
            }
        }
        return false;
    }

    final private boolean jj_3R_194() {
        if (jj_scan_token(COMMA)) return true;
        if (jj_3R_112()) return true;
        return false;
    }

    final private boolean jj_3R_290() {
        if (jj_scan_token(SUPER)) return true;
        if (jj_3R_77()) return true;
        return false;
    }

    final private boolean jj_3_16() {
        if (jj_scan_token(LBRACKET)) return true;
        if (jj_scan_token(RBRACKET)) return true;
        return false;
    }

    final private boolean jj_3R_289() {
        if (jj_scan_token(EXTENDS)) return true;
        if (jj_3R_77()) return true;
        return false;
    }

    final private boolean jj_3R_277() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_289()) {
            jj_scanpos = xsp;
            if (jj_3R_290()) return true;
        }
        return false;
    }

    final private boolean jj_3R_256() {
        if (jj_3R_277()) return true;
        return false;
    }

    final private boolean jj_3R_151() {
        if (jj_scan_token(HOOK)) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_256()) jj_scanpos = xsp;
        return false;
    }

    final private boolean jj_3_17() {
        if (jj_3R_78()) return true;
        return false;
    }

    final private boolean jj_3R_112() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_150()) {
            jj_scanpos = xsp;
            if (jj_3R_151()) return true;
        }
        return false;
    }

    final private boolean jj_3R_150() {
        if (jj_3R_77()) return true;
        return false;
    }

    final private boolean jj_3_15() {
        if (jj_scan_token(LBRACKET)) return true;
        if (jj_scan_token(RBRACKET)) return true;
        return false;
    }

    final private boolean jj_3R_78() {
        if (jj_scan_token(LT)) return true;
        if (jj_3R_112()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_194()) {
                jj_scanpos = xsp;
                break;
            }
        }
        if (jj_scan_token(GT)) return true;
        return false;
    }

    final private boolean jj_3_18() {
        if (jj_scan_token(DOT)) return true;
        if (jj_scan_token(IDENTIFIER)) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3_19()) jj_scanpos = xsp;
        return false;
    }

    final private boolean jj_3R_149() {
        if (jj_scan_token(IDENTIFIER)) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3_17()) jj_scanpos = xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3_18()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_111() {
        if (jj_3R_149()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3_16()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_110() {
        if (jj_3R_83()) return true;
        Token xsp;
        if (jj_3_15()) return true;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3_15()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_77() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_110()) {
            jj_scanpos = xsp;
            if (jj_3R_111()) return true;
        }
        return false;
    }

    final private boolean jj_3_13() {
        if (jj_scan_token(THIS)) return true;
        if (jj_scan_token(DOT)) return true;
        return false;
    }

    final private boolean jj_3R_221() {
        if (jj_scan_token(THROWS)) return true;
        if (jj_3R_99()) return true;
        return false;
    }

    final private boolean jj_3R_103() {
        if (jj_3R_83()) return true;
        return false;
    }

    final private boolean jj_3R_72() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3_14()) {
            jj_scanpos = xsp;
            if (jj_3R_103()) return true;
        }
        return false;
    }

    final private boolean jj_3_14() {
        if (jj_3R_77()) return true;
        return false;
    }

    final private boolean jj_3R_74() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_scan_token(47)) jj_scanpos = xsp;
        if (jj_3R_104()) return true;
        return false;
    }

    final private boolean jj_3_12() {
        if (jj_3R_76()) return true;
        return false;
    }

    final private boolean jj_3R_108() {
        if (jj_3R_78()) return true;
        return false;
    }

    final private boolean jj_3R_107() {
        if (jj_scan_token(IDENTIFIER)) return true;
        if (jj_scan_token(DOT)) return true;
        return false;
    }

    final private boolean jj_3R_252() {
        if (jj_scan_token(LBRACKET)) return true;
        if (jj_scan_token(RBRACKET)) return true;
        return false;
    }

    final private boolean jj_3R_76() {
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_107()) {
                jj_scanpos = xsp;
                break;
            }
        }
        xsp = jj_scanpos;
        if (jj_3_13()) jj_scanpos = xsp;
        xsp = jj_scanpos;
        if (jj_3R_108()) jj_scanpos = xsp;
        xsp = jj_scanpos;
        if (jj_scan_token(52)) {
            jj_scanpos = xsp;
            if (jj_scan_token(49)) return true;
        }
        if (jj_3R_109()) return true;
        if (jj_scan_token(SEMICOLON)) return true;
        return false;
    }

    final private boolean jj_3R_134() {
        if (jj_scan_token(COMMA)) return true;
        if (jj_3R_133()) return true;
        return false;
    }

    final private boolean jj_3R_223() {
        if (jj_3R_49()) return true;
        return false;
    }

    final private boolean jj_3R_222() {
        if (jj_3R_76()) return true;
        return false;
    }

    final private boolean jj_3R_220() {
        if (jj_3R_97()) return true;
        return false;
    }

    final private boolean jj_3R_186() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_220()) jj_scanpos = xsp;
        if (jj_scan_token(IDENTIFIER)) return true;
        if (jj_3R_53()) return true;
        xsp = jj_scanpos;
        if (jj_3R_221()) jj_scanpos = xsp;
        if (jj_scan_token(LBRACE)) return true;
        xsp = jj_scanpos;
        if (jj_3R_222()) jj_scanpos = xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_223()) {
                jj_scanpos = xsp;
                break;
            }
        }
        if (jj_scan_token(RBRACE)) return true;
        return false;
    }

    final private boolean jj_3_11() {
        if (jj_scan_token(COMMA)) return true;
        if (jj_3R_75()) return true;
        return false;
    }

    final private boolean jj_3R_227() {
        if (jj_scan_token(THROWS)) return true;
        if (jj_3R_99()) return true;
        return false;
    }

    final private boolean jj_3R_98() {
        if (jj_3R_133()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_134()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_133() {
        if (jj_3R_50()) return true;
        if (jj_3R_72()) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_scan_token(119)) jj_scanpos = xsp;
        if (jj_3R_184()) return true;
        return false;
    }

    final private boolean jj_3R_53() {
        if (jj_scan_token(LPAREN)) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_98()) jj_scanpos = xsp;
        if (jj_scan_token(RPAREN)) return true;
        return false;
    }

    final private boolean jj_3_48() {
        if (jj_3R_72()) return true;
        if (jj_scan_token(IDENTIFIER)) return true;
        if (jj_scan_token(LPAREN)) return true;
        return false;
    }

    final private boolean jj_3R_226() {
        if (jj_scan_token(IDENTIFIER)) return true;
        if (jj_3R_53()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_252()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_228() {
        if (jj_3R_104()) return true;
        return false;
    }

    final private boolean jj_3R_225() {
        if (jj_3R_97()) return true;
        return false;
    }

    final private boolean jj_3R_292() {
        if (jj_3R_75()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3_11()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_188() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_225()) jj_scanpos = xsp;
        if (jj_3R_86()) return true;
        if (jj_3R_226()) return true;
        xsp = jj_scanpos;
        if (jj_3R_227()) jj_scanpos = xsp;
        xsp = jj_scanpos;
        if (jj_3R_228()) {
            jj_scanpos = xsp;
            if (jj_scan_token(81)) return true;
        }
        return false;
    }

    final private boolean jj_3R_198() {
        if (jj_scan_token(ASSIGN)) return true;
        if (jj_3R_75()) return true;
        return false;
    }

    final private boolean jj_3R_224() {
        if (jj_scan_token(COMMA)) return true;
        if (jj_3R_161()) return true;
        return false;
    }

    final private boolean jj_3_47() {
        if (jj_scan_token(COMMA)) return true;
        if (jj_3R_93()) return true;
        return false;
    }

    final private boolean jj_3R_217() {
        if (jj_scan_token(LBRACKET)) return true;
        if (jj_scan_token(RBRACKET)) return true;
        return false;
    }

    final private boolean jj_3R_147() {
        if (jj_scan_token(LBRACE)) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_292()) jj_scanpos = xsp;
        xsp = jj_scanpos;
        if (jj_scan_token(82)) jj_scanpos = xsp;
        if (jj_scan_token(RBRACE)) return true;
        return false;
    }

    final private boolean jj_3R_73() {
        if (jj_scan_token(LBRACKET)) return true;
        if (jj_scan_token(RBRACKET)) return true;
        return false;
    }

    final private boolean jj_3R_106() {
        if (jj_3R_56()) return true;
        return false;
    }

    final private boolean jj_3R_105() {
        if (jj_3R_147()) return true;
        return false;
    }

    final private boolean jj_3R_75() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_105()) {
            jj_scanpos = xsp;
            if (jj_3R_106()) return true;
        }
        return false;
    }

    final private boolean jj_3R_184() {
        if (jj_scan_token(IDENTIFIER)) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_217()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_160() {
        if (jj_scan_token(LBRACE)) return true;
        if (jj_3R_93()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3_47()) {
                jj_scanpos = xsp;
                break;
            }
        }
        xsp = jj_scanpos;
        if (jj_scan_token(82)) jj_scanpos = xsp;
        if (jj_scan_token(RBRACE)) return true;
        return false;
    }

    final private boolean jj_3R_276() {
        if (jj_scan_token(COMMA)) return true;
        if (jj_3R_275()) return true;
        return false;
    }

    final private boolean jj_3R_161() {
        if (jj_3R_184()) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_198()) jj_scanpos = xsp;
        return false;
    }

    final private boolean jj_3R_127() {
        if (jj_3R_101()) return true;
        return false;
    }

    final private boolean jj_3_9() {
        if (jj_3R_72()) return true;
        if (jj_scan_token(IDENTIFIER)) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_73()) {
                jj_scanpos = xsp;
                break;
            }
        }
        xsp = jj_scanpos;
        if (jj_scan_token(82)) {
            jj_scanpos = xsp;
            if (jj_scan_token(85)) {
                jj_scanpos = xsp;
                if (jj_scan_token(81)) return true;
            }
        }
        return false;
    }

    final private boolean jj_3R_126() {
        if (jj_3R_160()) return true;
        return false;
    }

    final private boolean jj_3R_71() {
        if (jj_3R_97()) return true;
        return false;
    }

    final private boolean jj_3R_93() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_125()) {
            jj_scanpos = xsp;
            if (jj_3R_126()) {
                jj_scanpos = xsp;
                if (jj_3R_127()) return true;
            }
        }
        return false;
    }

    final private boolean jj_3R_125() {
        if (jj_3R_102()) return true;
        return false;
    }

    final private boolean jj_3_8() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_71()) jj_scanpos = xsp;
        if (jj_scan_token(IDENTIFIER)) return true;
        if (jj_scan_token(LPAREN)) return true;
        return false;
    }

    final private boolean jj_3R_187() {
        if (jj_3R_72()) return true;
        if (jj_3R_161()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_224()) {
                jj_scanpos = xsp;
                break;
            }
        }
        if (jj_scan_token(SEMICOLON)) return true;
        return false;
    }

    final private boolean jj_3R_275() {
        if (jj_scan_token(IDENTIFIER)) return true;
        if (jj_scan_token(ASSIGN)) return true;
        if (jj_3R_93()) return true;
        return false;
    }

    final private boolean jj_3R_140() {
        if (jj_3R_188()) return true;
        return false;
    }

    final private boolean jj_3R_139() {
        if (jj_3R_187()) return true;
        return false;
    }

    final private boolean jj_3R_249() {
        if (jj_scan_token(BIT_AND)) return true;
        if (jj_3R_149()) return true;
        return false;
    }

    final private boolean jj_3R_138() {
        if (jj_3R_186()) return true;
        return false;
    }

    final private boolean jj_3R_255() {
        if (jj_3R_275()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_276()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_231() {
        if (jj_3R_255()) return true;
        return false;
    }

    final private boolean jj_3R_137() {
        if (jj_3R_185()) return true;
        return false;
    }

    final private boolean jj_3R_92() {
        if (jj_scan_token(IDENTIFIER)) return true;
        if (jj_scan_token(ASSIGN)) return true;
        return false;
    }

    final private boolean jj_3R_136() {
        if (jj_3R_130()) return true;
        return false;
    }

    final private boolean jj_3R_192() {
        if (jj_scan_token(AT)) return true;
        if (jj_3R_91()) return true;
        if (jj_scan_token(LPAREN)) return true;
        if (jj_3R_93()) return true;
        if (jj_scan_token(RPAREN)) return true;
        return false;
    }

    final private boolean jj_3R_286() {
        if (jj_3R_182()) return true;
        return false;
    }

    final private boolean jj_3R_100() {
        if (jj_3R_50()) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_136()) {
            jj_scanpos = xsp;
            if (jj_3R_137()) {
                jj_scanpos = xsp;
                if (jj_3R_138()) {
                    jj_scanpos = xsp;
                    if (jj_3R_139()) {
                        jj_scanpos = xsp;
                        if (jj_3R_140()) return true;
                    }
                }
            }
        }
        return false;
    }

    final private boolean jj_3R_193() {
        if (jj_scan_token(AT)) return true;
        if (jj_3R_91()) return true;
        return false;
    }

    final private boolean jj_3_46() {
        if (jj_scan_token(AT)) return true;
        if (jj_3R_91()) return true;
        if (jj_scan_token(LPAREN)) return true;
        return false;
    }

    final private boolean jj_3_10() {
        if (jj_3R_74()) return true;
        return false;
    }

    final private boolean jj_3R_55() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3_10()) {
            jj_scanpos = xsp;
            if (jj_3R_100()) {
                jj_scanpos = xsp;
                if (jj_scan_token(81)) return true;
            }
        }
        return false;
    }

    final private boolean jj_3R_191() {
        if (jj_scan_token(AT)) return true;
        if (jj_3R_91()) return true;
        if (jj_scan_token(LPAREN)) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_231()) jj_scanpos = xsp;
        if (jj_scan_token(RPAREN)) return true;
        return false;
    }

    final private boolean jj_3_45() {
        if (jj_scan_token(AT)) return true;
        if (jj_3R_91()) return true;
        if (jj_scan_token(LPAREN)) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_92()) {
            jj_scanpos = xsp;
            if (jj_scan_token(76)) return true;
        }
        return false;
    }

    final private boolean jj_3R_215() {
        if (jj_3R_55()) return true;
        return false;
    }

    final private boolean jj_3R_132() {
        if (jj_scan_token(COMMA)) return true;
        if (jj_3R_131()) return true;
        return false;
    }

    final private boolean jj_3R_183() {
        if (jj_3R_216()) return true;
        return false;
    }

    final private boolean jj_3R_285() {
        if (jj_3R_109()) return true;
        return false;
    }

    final private boolean jj_3R_145() {
        if (jj_3R_193()) return true;
        return false;
    }

    final private boolean jj_3R_182() {
        if (jj_scan_token(LBRACE)) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_215()) {
                jj_scanpos = xsp;
                break;
            }
        }
        if (jj_scan_token(RBRACE)) return true;
        return false;
    }

    final private boolean jj_3R_144() {
        if (jj_3R_192()) return true;
        return false;
    }

    final private boolean jj_3R_113() {
        return false;
    }

    final private boolean jj_3R_102() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_143()) {
            jj_scanpos = xsp;
            if (jj_3R_144()) {
                jj_scanpos = xsp;
                if (jj_3R_145()) return true;
            }
        }
        return false;
    }

    final private boolean jj_3R_143() {
        if (jj_3R_191()) return true;
        return false;
    }

    final private boolean jj_3R_216() {
        if (jj_scan_token(EXTENDS)) return true;
        if (jj_3R_149()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_249()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_131() {
        if (jj_scan_token(IDENTIFIER)) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_183()) jj_scanpos = xsp;
        return false;
    }

    final private boolean jj_3R_114() {
        return false;
    }

    final private boolean jj_3_7() {
        if (jj_scan_token(COMMA)) return true;
        if (jj_3R_70()) return true;
        return false;
    }

    final private boolean jj_3R_80() {
        Token xsp;
        xsp = jj_scanpos;
        lookingAhead = true;
        jj_semLA = getToken(1).kind == GT &&
                ((Token.GTToken) getToken(1)).realKind == RSIGNEDSHIFT;
        lookingAhead = false;
        if (!jj_semLA || jj_3R_113()) return true;
        if (jj_scan_token(GT)) return true;
        if (jj_scan_token(GT)) return true;
        return false;
    }

    final private boolean jj_3R_97() {
        if (jj_scan_token(LT)) return true;
        if (jj_3R_131()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_132()) {
                jj_scanpos = xsp;
                break;
            }
        }
        if (jj_scan_token(GT)) return true;
        return false;
    }

    final private boolean jj_3R_272() {
        if (jj_3R_55()) return true;
        return false;
    }

    final private boolean jj_3R_70() {
        if (jj_3R_50()) return true;
        if (jj_scan_token(IDENTIFIER)) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_285()) jj_scanpos = xsp;
        xsp = jj_scanpos;
        if (jj_3R_286()) jj_scanpos = xsp;
        return false;
    }

    final private boolean jj_3R_81() {
        Token xsp;
        xsp = jj_scanpos;
        lookingAhead = true;
        jj_semLA = getToken(1).kind == GT &&
                ((Token.GTToken) getToken(1)).realKind == RUNSIGNEDSHIFT;
        lookingAhead = false;
        if (!jj_semLA || jj_3R_114()) return true;
        if (jj_scan_token(GT)) return true;
        if (jj_scan_token(GT)) return true;
        if (jj_scan_token(GT)) return true;
        return false;
    }

    final private boolean jj_3R_251() {
        if (jj_scan_token(SEMICOLON)) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_272()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_250() {
        if (jj_3R_70()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3_7()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_246() {
        if (jj_scan_token(FINALLY)) return true;
        if (jj_3R_104()) return true;
        return false;
    }

    final private boolean jj_3R_219() {
        if (jj_scan_token(LBRACE)) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_250()) jj_scanpos = xsp;
        xsp = jj_scanpos;
        if (jj_scan_token(82)) jj_scanpos = xsp;
        xsp = jj_scanpos;
        if (jj_3R_251()) jj_scanpos = xsp;
        if (jj_scan_token(RBRACE)) return true;
        return false;
    }

    final private boolean jj_3R_245() {
        if (jj_scan_token(CATCH)) return true;
        if (jj_scan_token(LPAREN)) return true;
        if (jj_3R_133()) return true;
        if (jj_scan_token(RPAREN)) return true;
        if (jj_3R_104()) return true;
        return false;
    }

    final private boolean jj_3R_212() {
        if (jj_scan_token(TRY)) return true;
        if (jj_3R_104()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_245()) {
                jj_scanpos = xsp;
                break;
            }
        }
        xsp = jj_scanpos;
        if (jj_3R_246()) jj_scanpos = xsp;
        return false;
    }

    final private boolean jj_3R_218() {
        if (jj_3R_214()) return true;
        return false;
    }

    final private boolean jj_3R_185() {
        if (jj_scan_token(ENUM)) return true;
        if (jj_scan_token(IDENTIFIER)) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_218()) jj_scanpos = xsp;
        if (jj_3R_219()) return true;
        return false;
    }

    final private boolean jj_3R_211() {
        if (jj_scan_token(SYNCHRONIZED)) return true;
        if (jj_scan_token(LPAREN)) return true;
        if (jj_3R_56()) return true;
        if (jj_scan_token(RPAREN)) return true;
        if (jj_3R_104()) return true;
        return false;
    }

    final private boolean jj_3R_244() {
        if (jj_3R_56()) return true;
        return false;
    }

    final private boolean jj_3R_248() {
        if (jj_scan_token(COMMA)) return true;
        if (jj_3R_149()) return true;
        return false;
    }

    final private boolean jj_3R_214() {
        if (jj_scan_token(IMPLEMENTS)) return true;
        if (jj_3R_149()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_248()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_210() {
        if (jj_scan_token(THROW)) return true;
        if (jj_3R_56()) return true;
        if (jj_scan_token(SEMICOLON)) return true;
        return false;
    }

    final private boolean jj_3R_271() {
        if (jj_3R_284()) return true;
        return false;
    }

    final private boolean jj_3R_299() {
        if (jj_scan_token(COMMA)) return true;
        if (jj_3R_201()) return true;
        return false;
    }

    final private boolean jj_3R_209() {
        if (jj_scan_token(RETURN)) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_244()) jj_scanpos = xsp;
        if (jj_scan_token(SEMICOLON)) return true;
        return false;
    }

    final private boolean jj_3R_247() {
        if (jj_scan_token(COMMA)) return true;
        if (jj_3R_149()) return true;
        return false;
    }

    final private boolean jj_3R_213() {
        if (jj_scan_token(EXTENDS)) return true;
        if (jj_3R_149()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_247()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_208() {
        if (jj_scan_token(CONTINUE)) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_scan_token(72)) jj_scanpos = xsp;
        if (jj_scan_token(SEMICOLON)) return true;
        return false;
    }

    final private boolean jj_3R_178() {
        if (jj_scan_token(INTERFACE)) return true;
        return false;
    }

    final private boolean jj_3R_207() {
        if (jj_scan_token(BREAK)) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_scan_token(72)) jj_scanpos = xsp;
        if (jj_scan_token(SEMICOLON)) return true;
        return false;
    }

    final private boolean jj_3R_181() {
        if (jj_3R_214()) return true;
        return false;
    }

    final private boolean jj_3R_180() {
        if (jj_3R_213()) return true;
        return false;
    }

    final private boolean jj_3R_179() {
        if (jj_3R_97()) return true;
        return false;
    }

    final private boolean jj_3R_284() {
        if (jj_3R_296()) return true;
        return false;
    }

    final private boolean jj_3R_270() {
        if (jj_3R_56()) return true;
        return false;
    }

    final private boolean jj_3R_130() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_scan_token(16)) {
            jj_scanpos = xsp;
            if (jj_3R_178()) return true;
        }
        if (jj_scan_token(IDENTIFIER)) return true;
        xsp = jj_scanpos;
        if (jj_3R_179()) jj_scanpos = xsp;
        xsp = jj_scanpos;
        if (jj_3R_180()) jj_scanpos = xsp;
        xsp = jj_scanpos;
        if (jj_3R_181()) jj_scanpos = xsp;
        if (jj_3R_182()) return true;
        return false;
    }

    final private boolean jj_3_44() {
        if (jj_3R_50()) return true;
        if (jj_3R_72()) return true;
        if (jj_scan_token(IDENTIFIER)) return true;
        return false;
    }

    final private boolean jj_3R_296() {
        if (jj_3R_201()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_299()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_241() {
        if (jj_scan_token(ELSE)) return true;
        if (jj_3R_129()) return true;
        return false;
    }

    final private boolean jj_3R_295() {
        if (jj_3R_296()) return true;
        return false;
    }

    final private boolean jj_3_43() {
        if (jj_3R_50()) return true;
        if (jj_3R_72()) return true;
        if (jj_scan_token(IDENTIFIER)) return true;
        if (jj_scan_token(COLON)) return true;
        return false;
    }

    final private boolean jj_3R_294() {
        if (jj_3R_128()) return true;
        return false;
    }

    final private boolean jj_3R_283() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_294()) {
            jj_scanpos = xsp;
            if (jj_3R_295()) return true;
        }
        return false;
    }

    final private boolean jj_3R_269() {
        if (jj_3R_283()) return true;
        return false;
    }

    final private boolean jj_3R_243() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_269()) jj_scanpos = xsp;
        if (jj_scan_token(SEMICOLON)) return true;
        xsp = jj_scanpos;
        if (jj_3R_270()) jj_scanpos = xsp;
        if (jj_scan_token(SEMICOLON)) return true;
        xsp = jj_scanpos;
        if (jj_3R_271()) jj_scanpos = xsp;
        return false;
    }

    final private boolean jj_3R_242() {
        if (jj_3R_50()) return true;
        if (jj_3R_72()) return true;
        if (jj_scan_token(IDENTIFIER)) return true;
        if (jj_scan_token(COLON)) return true;
        if (jj_3R_56()) return true;
        return false;
    }

    final private boolean jj_3R_54() {
        if (jj_scan_token(THROWS)) return true;
        if (jj_3R_99()) return true;
        return false;
    }

    final private boolean jj_3R_206() {
        if (jj_scan_token(FOR)) return true;
        if (jj_scan_token(LPAREN)) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_242()) {
            jj_scanpos = xsp;
            if (jj_3R_243()) return true;
        }
        if (jj_scan_token(RPAREN)) return true;
        if (jj_3R_129()) return true;
        return false;
    }

    final private boolean jj_3R_69() {
        if (jj_3R_102()) return true;
        return false;
    }

    final private boolean jj_3R_205() {
        if (jj_scan_token(DO)) return true;
        if (jj_3R_129()) return true;
        if (jj_scan_token(WHILE)) return true;
        if (jj_scan_token(LPAREN)) return true;
        if (jj_3R_56()) return true;
        if (jj_scan_token(RPAREN)) return true;
        if (jj_scan_token(SEMICOLON)) return true;
        return false;
    }

    final private boolean jj_3R_68() {
        if (jj_scan_token(STRICTFP)) return true;
        return false;
    }

    final private boolean jj_3R_67() {
        if (jj_scan_token(VOLATILE)) return true;
        return false;
    }

    final private boolean jj_3R_66() {
        if (jj_scan_token(TRANSIENT)) return true;
        return false;
    }

    final private boolean jj_3R_204() {
        if (jj_scan_token(WHILE)) return true;
        if (jj_scan_token(LPAREN)) return true;
        if (jj_3R_56()) return true;
        if (jj_scan_token(RPAREN)) return true;
        if (jj_3R_129()) return true;
        return false;
    }

    final private boolean jj_3R_65() {
        if (jj_scan_token(NATIVE)) return true;
        return false;
    }

    final private boolean jj_3R_64() {
        if (jj_scan_token(SYNCHRONIZED)) return true;
        return false;
    }

    final private boolean jj_3R_63() {
        if (jj_scan_token(ABSTRACT)) return true;
        return false;
    }

    final private boolean jj_3R_268() {
        if (jj_3R_49()) return true;
        return false;
    }

    final private boolean jj_3R_203() {
        if (jj_scan_token(IF)) return true;
        if (jj_scan_token(LPAREN)) return true;
        if (jj_3R_56()) return true;
        if (jj_scan_token(RPAREN)) return true;
        if (jj_3R_129()) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_241()) jj_scanpos = xsp;
        return false;
    }

    final private boolean jj_3R_62() {
        if (jj_scan_token(FINAL)) return true;
        return false;
    }

    final private boolean jj_3R_61() {
        if (jj_scan_token(PRIVATE)) return true;
        return false;
    }

    final private boolean jj_3R_162() {
        if (jj_scan_token(COMMA)) return true;
        if (jj_3R_161()) return true;
        return false;
    }

    final private boolean jj_3R_60() {
        if (jj_scan_token(PROTECTED)) return true;
        return false;
    }

    final private boolean jj_3R_59() {
        if (jj_scan_token(STATIC)) return true;
        return false;
    }

    final private boolean jj_3R_58() {
        if (jj_scan_token(PUBLIC)) return true;
        return false;
    }

    final private boolean jj_3R_282() {
        if (jj_scan_token(_DEFAULT)) return true;
        if (jj_scan_token(COLON)) return true;
        return false;
    }

    final private boolean jj_3_6() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_58()) {
            jj_scanpos = xsp;
            if (jj_3R_59()) {
                jj_scanpos = xsp;
                if (jj_3R_60()) {
                    jj_scanpos = xsp;
                    if (jj_3R_61()) {
                        jj_scanpos = xsp;
                        if (jj_3R_62()) {
                            jj_scanpos = xsp;
                            if (jj_3R_63()) {
                                jj_scanpos = xsp;
                                if (jj_3R_64()) {
                                    jj_scanpos = xsp;
                                    if (jj_3R_65()) {
                                        jj_scanpos = xsp;
                                        if (jj_3R_66()) {
                                            jj_scanpos = xsp;
                                            if (jj_3R_67()) {
                                                jj_scanpos = xsp;
                                                if (jj_3R_68()) {
                                                    jj_scanpos = xsp;
                                                    if (jj_3R_69()) return true;
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        return false;
    }

    final private boolean jj_3R_281() {
        if (jj_scan_token(CASE)) return true;
        if (jj_3R_56()) return true;
        if (jj_scan_token(COLON)) return true;
        return false;
    }

    final private boolean jj_3R_267() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_281()) {
            jj_scanpos = xsp;
            if (jj_3R_282()) return true;
        }
        return false;
    }

    final private boolean jj_3R_50() {
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3_6()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_240() {
        if (jj_3R_267()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_268()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3_42() {
        if (jj_3R_90()) return true;
        if (jj_3R_79()) return true;
        return false;
    }

    final private boolean jj_3R_202() {
        if (jj_scan_token(SWITCH)) return true;
        if (jj_scan_token(LPAREN)) return true;
        if (jj_3R_56()) return true;
        if (jj_scan_token(RPAREN)) return true;
        if (jj_scan_token(LBRACE)) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_240()) {
                jj_scanpos = xsp;
                break;
            }
        }
        if (jj_scan_token(RBRACE)) return true;
        return false;
    }

    final private boolean jj_3R_239() {
        if (jj_3R_266()) return true;
        return false;
    }

    final private boolean jj_3R_57() {
        if (jj_3R_102()) return true;
        return false;
    }

    final private boolean jj_3R_52() {
        if (jj_3R_86()) return true;
        return false;
    }

    final private boolean jj_3R_238() {
        if (jj_3R_265()) return true;
        return false;
    }

    final private boolean jj_3_5() {
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_57()) {
                jj_scanpos = xsp;
                break;
            }
        }
        if (jj_scan_token(PACKAGE)) return true;
        return false;
    }

    final private boolean jj_3R_237() {
        if (jj_3R_264()) return true;
        return false;
    }

    final private boolean jj_3R_201() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_236()) {
            jj_scanpos = xsp;
            if (jj_3R_237()) {
                jj_scanpos = xsp;
                if (jj_3R_238()) {
                    jj_scanpos = xsp;
                    if (jj_3R_239()) return true;
                }
            }
        }
        return false;
    }

    final private boolean jj_3R_236() {
        if (jj_3R_263()) return true;
        return false;
    }

    final private boolean jj_3R_200() {
        if (jj_scan_token(SEMICOLON)) return true;
        return false;
    }

    final private boolean jj_3_41() {
        if (jj_3R_50()) return true;
        if (jj_3R_72()) return true;
        if (jj_scan_token(IDENTIFIER)) return true;
        return false;
    }

    final private boolean jj_3R_128() {
        if (jj_3R_50()) return true;
        if (jj_3R_72()) return true;
        if (jj_3R_161()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_162()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_51() {
        if (jj_3R_97()) return true;
        return false;
    }

    final private boolean jj_3R_235() {
        if (jj_scan_token(COLON)) return true;
        if (jj_3R_56()) return true;
        return false;
    }

    final private boolean jj_3R_96() {
        if (jj_3R_130()) return true;
        return false;
    }

    final private boolean jj_3R_95() {
        if (jj_3R_129()) return true;
        return false;
    }

    final private boolean jj_3_4() {
        if (jj_3R_56()) return true;
        return false;
    }

    final private boolean jj_3R_94() {
        if (jj_3R_128()) return true;
        if (jj_scan_token(SEMICOLON)) return true;
        return false;
    }

    final private boolean jj_3R_49() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_94()) {
            jj_scanpos = xsp;
            if (jj_3R_95()) {
                jj_scanpos = xsp;
                if (jj_3R_96()) return true;
            }
        }
        return false;
    }

    final private boolean jj_3R_146() {
        if (jj_3R_49()) return true;
        return false;
    }

    final private boolean jj_3_3() {
        if (jj_3R_55()) return true;
        return false;
    }

    final private boolean jj_3R_104() {
        if (jj_scan_token(LBRACE)) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_146()) {
                jj_scanpos = xsp;
                break;
            }
        }
        if (jj_scan_token(RBRACE)) return true;
        return false;
    }

    final private boolean jj_3_2() {
        if (jj_3R_50()) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_51()) jj_scanpos = xsp;
        xsp = jj_scanpos;
        if (jj_3R_52()) jj_scanpos = xsp;
        if (jj_scan_token(IDENTIFIER)) return true;
        if (jj_3R_53()) return true;
        xsp = jj_scanpos;
        if (jj_3R_54()) jj_scanpos = xsp;
        if (jj_scan_token(LBRACE)) return true;
        return false;
    }

    final private boolean jj_3R_89() {
        if (jj_scan_token(IDENTIFIER)) return true;
        if (jj_scan_token(COLON)) return true;
        if (jj_3R_129()) return true;
        return false;
    }

    final private boolean jj_3_1() {
        if (jj_3R_49()) return true;
        return false;
    }

    final private boolean jj_3R_199() {
        if (jj_scan_token(ASSERT)) return true;
        if (jj_3R_56()) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_235()) jj_scanpos = xsp;
        if (jj_scan_token(SEMICOLON)) return true;
        return false;
    }

    final private boolean jj_3R_177() {
        if (jj_3R_212()) return true;
        return false;
    }

    final private boolean jj_3R_176() {
        if (jj_3R_211()) return true;
        return false;
    }

    final private boolean jj_3_38() {
        if (jj_scan_token(LBRACKET)) return true;
        if (jj_scan_token(RBRACKET)) return true;
        return false;
    }

    final private boolean jj_3R_175() {
        if (jj_3R_210()) return true;
        return false;
    }

    final private boolean jj_3R_174() {
        if (jj_3R_209()) return true;
        return false;
    }

    final private boolean jj_3R_173() {
        if (jj_3R_208()) return true;
        return false;
    }

    final private boolean jj_3R_172() {
        if (jj_3R_207()) return true;
        return false;
    }

    final private boolean jj_3R_171() {
        if (jj_3R_206()) return true;
        return false;
    }

    final private boolean jj_3R_170() {
        if (jj_3R_205()) return true;
        return false;
    }

    final private boolean jj_3R_169() {
        if (jj_3R_204()) return true;
        return false;
    }

    final private boolean jj_3R_168() {
        if (jj_3R_203()) return true;
        return false;
    }

    final private boolean jj_3R_167() {
        if (jj_3R_202()) return true;
        return false;
    }

    final private boolean jj_3R_166() {
        if (jj_3R_201()) return true;
        if (jj_scan_token(SEMICOLON)) return true;
        return false;
    }

    final private boolean jj_3R_165() {
        if (jj_3R_200()) return true;
        return false;
    }

    final private boolean jj_3R_164() {
        if (jj_3R_104()) return true;
        return false;
    }

    final private boolean jj_3R_163() {
        if (jj_3R_199()) return true;
        return false;
    }

    final private boolean jj_3R_260() {
        if (jj_3R_78()) return true;
        return false;
    }

    final private boolean jj_3_40() {
        if (jj_3R_89()) return true;
        return false;
    }

    final private boolean jj_3R_129() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3_40()) {
            jj_scanpos = xsp;
            if (jj_3R_163()) {
                jj_scanpos = xsp;
                if (jj_3R_164()) {
                    jj_scanpos = xsp;
                    if (jj_3R_165()) {
                        jj_scanpos = xsp;
                        if (jj_3R_166()) {
                            jj_scanpos = xsp;
                            if (jj_3R_167()) {
                                jj_scanpos = xsp;
                                if (jj_3R_168()) {
                                    jj_scanpos = xsp;
                                    if (jj_3R_169()) {
                                        jj_scanpos = xsp;
                                        if (jj_3R_170()) {
                                            jj_scanpos = xsp;
                                            if (jj_3R_171()) {
                                                jj_scanpos = xsp;
                                                if (jj_3R_172()) {
                                                    jj_scanpos = xsp;
                                                    if (jj_3R_173()) {
                                                        jj_scanpos = xsp;
                                                        if (jj_3R_174()) {
                                                            jj_scanpos = xsp;
                                                            if (jj_3R_175()) {
                                                                jj_scanpos = xsp;
                                                                if (jj_3R_176()) {
                                                                    jj_scanpos = xsp;
                                                                    if (jj_3R_177())
                                                                        return true;
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        return false;
    }

    final private boolean jj_3R_279() {
        if (jj_3R_182()) return true;
        return false;
    }

    final private boolean jj_3R_291() {
        if (jj_scan_token(LBRACKET)) return true;
        if (jj_scan_token(RBRACKET)) return true;
        return false;
    }

    final private boolean jj_3R_278() {
        Token xsp;
        if (jj_3R_291()) return true;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_291()) {
                jj_scanpos = xsp;
                break;
            }
        }
        if (jj_3R_147()) return true;
        return false;
    }

    final private boolean jj_3_37() {
        if (jj_scan_token(LBRACKET)) return true;
        if (jj_3R_56()) return true;
        if (jj_scan_token(RBRACKET)) return true;
        return false;
    }

    final private boolean jj_3_39() {
        Token xsp;
        if (jj_3_37()) return true;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3_37()) {
                jj_scanpos = xsp;
                break;
            }
        }
        while (true) {
            xsp = jj_scanpos;
            if (jj_3_38()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_259() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3_39()) {
            jj_scanpos = xsp;
            if (jj_3R_278()) return true;
        }
        return false;
    }

    final private boolean jj_3R_262() {
        if (jj_3R_109()) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_279()) jj_scanpos = xsp;
        return false;
    }

    final private boolean jj_3R_232() {
        if (jj_scan_token(COMMA)) return true;
        if (jj_3R_56()) return true;
        return false;
    }

    final private boolean jj_3R_261() {
        if (jj_3R_259()) return true;
        return false;
    }

    final private boolean jj_3R_123() {
        if (jj_scan_token(NEW)) return true;
        if (jj_3R_149()) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_260()) jj_scanpos = xsp;
        xsp = jj_scanpos;
        if (jj_3R_261()) {
            jj_scanpos = xsp;
            if (jj_3R_262()) return true;
        }
        return false;
    }

    final private boolean jj_3R_87() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3_36()) {
            jj_scanpos = xsp;
            if (jj_3R_123()) return true;
        }
        return false;
    }

    final private boolean jj_3_36() {
        if (jj_scan_token(NEW)) return true;
        if (jj_3R_83()) return true;
        if (jj_3R_259()) return true;
        return false;
    }

    final private boolean jj_3R_148() {
        if (jj_3R_195()) return true;
        return false;
    }

    final private boolean jj_3R_195() {
        if (jj_3R_56()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_232()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_109() {
        if (jj_scan_token(LPAREN)) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_148()) jj_scanpos = xsp;
        if (jj_scan_token(RPAREN)) return true;
        return false;
    }

    final private boolean jj_3R_258() {
        if (jj_scan_token(NULL)) return true;
        return false;
    }

    final private boolean jj_3R_257() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_scan_token(56)) {
            jj_scanpos = xsp;
            if (jj_scan_token(25)) return true;
        }
        return false;
    }

    final private boolean jj_3R_234() {
        if (jj_3R_258()) return true;
        return false;
    }

    final private boolean jj_3R_233() {
        if (jj_3R_257()) return true;
        return false;
    }

    final private boolean jj_3R_196() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_scan_token(61)) {
            jj_scanpos = xsp;
            if (jj_scan_token(65)) {
                jj_scanpos = xsp;
                if (jj_scan_token(70)) {
                    jj_scanpos = xsp;
                    if (jj_scan_token(71)) {
                        jj_scanpos = xsp;
                        if (jj_3R_233()) {
                            jj_scanpos = xsp;
                            if (jj_3R_234()) return true;
                        }
                    }
                }
            }
        }
        return false;
    }

    final private boolean jj_3R_152() {
        if (jj_3R_196()) return true;
        return false;
    }

    final private boolean jj_3R_121() {
        if (jj_3R_109()) return true;
        return false;
    }

    final private boolean jj_3R_120() {
        if (jj_scan_token(DOT)) return true;
        if (jj_scan_token(IDENTIFIER)) return true;
        return false;
    }

    final private boolean jj_3_33() {
        if (jj_scan_token(DOT)) return true;
        if (jj_scan_token(THIS)) return true;
        return false;
    }

    final private boolean jj_3R_119() {
        if (jj_scan_token(LBRACKET)) return true;
        if (jj_3R_56()) return true;
        if (jj_scan_token(RBRACKET)) return true;
        return false;
    }

    final private boolean jj_3_32() {
        if (jj_scan_token(DOT)) return true;
        if (jj_scan_token(SUPER)) return true;
        if (jj_scan_token(DOT)) return true;
        return false;
    }

    final private boolean jj_3_35() {
        if (jj_3R_88()) return true;
        return false;
    }

    final private boolean jj_3_34() {
        if (jj_scan_token(DOT)) return true;
        if (jj_3R_87()) return true;
        return false;
    }

    final private boolean jj_3R_118() {
        if (jj_scan_token(DOT)) return true;
        if (jj_scan_token(THIS)) return true;
        return false;
    }

    final private boolean jj_3_31() {
        if (jj_3R_86()) return true;
        if (jj_scan_token(DOT)) return true;
        if (jj_scan_token(CLASS)) return true;
        return false;
    }

    final private boolean jj_3R_117() {
        if (jj_scan_token(DOT)) return true;
        if (jj_scan_token(SUPER)) return true;
        return false;
    }

    final private boolean jj_3R_84() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_117()) {
            jj_scanpos = xsp;
            if (jj_3R_118()) {
                jj_scanpos = xsp;
                if (jj_3_34()) {
                    jj_scanpos = xsp;
                    if (jj_3_35()) {
                        jj_scanpos = xsp;
                        if (jj_3R_119()) {
                            jj_scanpos = xsp;
                            if (jj_3R_120()) {
                                jj_scanpos = xsp;
                                if (jj_3R_121()) return true;
                            }
                        }
                    }
                }
            }
        }
        return false;
    }

    final private boolean jj_3R_85() {
        if (jj_scan_token(IDENTIFIER)) return true;
        if (jj_scan_token(DOT)) return true;
        return false;
    }

    final private boolean jj_3R_159() {
        if (jj_3R_91()) return true;
        return false;
    }

    final private boolean jj_3_30() {
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_85()) {
                jj_scanpos = xsp;
                break;
            }
        }
        if (jj_scan_token(THIS)) return true;
        return false;
    }

    final private boolean jj_3R_158() {
        if (jj_3R_86()) return true;
        if (jj_scan_token(DOT)) return true;
        if (jj_scan_token(CLASS)) return true;
        return false;
    }

    final private boolean jj_3R_157() {
        if (jj_3R_87()) return true;
        return false;
    }

    final private boolean jj_3R_156() {
        if (jj_scan_token(LPAREN)) return true;
        if (jj_3R_56()) return true;
        if (jj_scan_token(RPAREN)) return true;
        return false;
    }

    final private boolean jj_3_29() {
        if (jj_3R_84()) return true;
        return false;
    }

    final private boolean jj_3R_155() {
        if (jj_scan_token(SUPER)) return true;
        if (jj_scan_token(DOT)) return true;
        if (jj_scan_token(IDENTIFIER)) return true;
        return false;
    }

    final private boolean jj_3R_197() {
        if (jj_scan_token(IDENTIFIER)) return true;
        if (jj_scan_token(DOT)) return true;
        return false;
    }

    final private boolean jj_3R_154() {
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_197()) {
                jj_scanpos = xsp;
                break;
            }
        }
        if (jj_scan_token(THIS)) return true;
        return false;
    }

    final private boolean jj_3R_124() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_153()) {
            jj_scanpos = xsp;
            if (jj_3R_154()) {
                jj_scanpos = xsp;
                if (jj_3R_155()) {
                    jj_scanpos = xsp;
                    if (jj_3R_156()) {
                        jj_scanpos = xsp;
                        if (jj_3R_157()) {
                            jj_scanpos = xsp;
                            if (jj_3R_158()) {
                                jj_scanpos = xsp;
                                if (jj_3R_159()) return true;
                            }
                        }
                    }
                }
            }
        }
        return false;
    }

    final private boolean jj_3R_153() {
        if (jj_3R_196()) return true;
        return false;
    }

    final private boolean jj_3R_88() {
        if (jj_scan_token(DOT)) return true;
        if (jj_3R_78()) return true;
        if (jj_scan_token(IDENTIFIER)) return true;
        return false;
    }

    final private boolean jj_3R_280() {
        if (jj_3R_293()) return true;
        return false;
    }

    final private boolean jj_3_28() {
        if (jj_scan_token(LPAREN)) return true;
        if (jj_3R_83()) return true;
        return false;
    }

    final private boolean jj_3R_90() {
        if (jj_3R_124()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3_29()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_319() {
        if (jj_scan_token(LPAREN)) return true;
        if (jj_3R_72()) return true;
        if (jj_scan_token(RPAREN)) return true;
        if (jj_3R_313()) return true;
        return false;
    }

    final private boolean jj_3R_318() {
        if (jj_scan_token(LPAREN)) return true;
        if (jj_3R_72()) return true;
        if (jj_scan_token(RPAREN)) return true;
        if (jj_3R_307()) return true;
        return false;
    }

    final private boolean jj_3R_317() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_318()) {
            jj_scanpos = xsp;
            if (jj_3R_319()) return true;
        }
        return false;
    }

    final private boolean jj_3R_293() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_scan_token(97)) {
            jj_scanpos = xsp;
            if (jj_scan_token(98)) return true;
        }
        return false;
    }

    final private boolean jj_3_27() {
        if (jj_scan_token(LPAREN)) return true;
        if (jj_3R_72()) return true;
        if (jj_scan_token(LBRACKET)) return true;
        return false;
    }

    final private boolean jj_3R_266() {
        if (jj_3R_90()) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_280()) jj_scanpos = xsp;
        return false;
    }

    final private boolean jj_3R_116() {
        if (jj_scan_token(LPAREN)) return true;
        if (jj_3R_72()) return true;
        if (jj_scan_token(RPAREN)) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_scan_token(88)) {
            jj_scanpos = xsp;
            if (jj_scan_token(87)) {
                jj_scanpos = xsp;
                if (jj_scan_token(75)) {
                    jj_scanpos = xsp;
                    if (jj_scan_token(72)) {
                        jj_scanpos = xsp;
                        if (jj_scan_token(52)) {
                            jj_scanpos = xsp;
                            if (jj_scan_token(49)) {
                                jj_scanpos = xsp;
                                if (jj_scan_token(39)) {
                                    jj_scanpos = xsp;
                                    if (jj_3R_152()) return true;
                                }
                            }
                        }
                    }
                }
            }
        }
        return false;
    }

    final private boolean jj_3R_115() {
        if (jj_scan_token(LPAREN)) return true;
        if (jj_3R_72()) return true;
        if (jj_scan_token(LBRACKET)) return true;
        if (jj_scan_token(RBRACKET)) return true;
        return false;
    }

    final private boolean jj_3R_82() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3_26()) {
            jj_scanpos = xsp;
            if (jj_3R_115()) {
                jj_scanpos = xsp;
                if (jj_3R_116()) return true;
            }
        }
        return false;
    }

    final private boolean jj_3_26() {
        if (jj_scan_token(LPAREN)) return true;
        if (jj_3R_83()) return true;
        return false;
    }

    final private boolean jj_3_25() {
        if (jj_3R_82()) return true;
        return false;
    }

    final private boolean jj_3_24() {
        if (jj_3R_81()) return true;
        return false;
    }

    final private boolean jj_3R_316() {
        if (jj_3R_266()) return true;
        return false;
    }

    final private boolean jj_3R_315() {
        if (jj_3R_317()) return true;
        return false;
    }

    final private boolean jj_3R_314() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_scan_token(88)) {
            jj_scanpos = xsp;
            if (jj_scan_token(87)) return true;
        }
        if (jj_3R_307()) return true;
        return false;
    }

    final private boolean jj_3R_313() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_314()) {
            jj_scanpos = xsp;
            if (jj_3R_315()) {
                jj_scanpos = xsp;
                if (jj_3R_316()) return true;
            }
        }
        return false;
    }

    final private boolean jj_3R_264() {
        if (jj_scan_token(DECR)) return true;
        if (jj_3R_90()) return true;
        return false;
    }

    final private boolean jj_3R_306() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_scan_token(99)) {
            jj_scanpos = xsp;
            if (jj_scan_token(100)) return true;
        }
        if (jj_3R_305()) return true;
        return false;
    }

    final private boolean jj_3R_308() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_scan_token(101)) {
            jj_scanpos = xsp;
            if (jj_scan_token(102)) {
                jj_scanpos = xsp;
                if (jj_scan_token(106)) return true;
            }
        }
        if (jj_3R_307()) return true;
        return false;
    }

    final private boolean jj_3_23() {
        if (jj_3R_80()) return true;
        return false;
    }

    final private boolean jj_3R_263() {
        if (jj_scan_token(INCR)) return true;
        if (jj_3R_90()) return true;
        return false;
    }

    final private boolean jj_3R_312() {
        if (jj_3R_313()) return true;
        return false;
    }

    final private boolean jj_3_22() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_scan_token(107)) {
            jj_scanpos = xsp;
            if (jj_3_23()) {
                jj_scanpos = xsp;
                if (jj_3_24()) return true;
            }
        }
        if (jj_3R_304()) return true;
        return false;
    }

    final private boolean jj_3R_311() {
        if (jj_3R_264()) return true;
        return false;
    }

    final private boolean jj_3R_310() {
        if (jj_3R_263()) return true;
        return false;
    }

    final private boolean jj_3R_309() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_scan_token(99)) {
            jj_scanpos = xsp;
            if (jj_scan_token(100)) return true;
        }
        if (jj_3R_307()) return true;
        return false;
    }

    final private boolean jj_3R_307() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_309()) {
            jj_scanpos = xsp;
            if (jj_3R_310()) {
                jj_scanpos = xsp;
                if (jj_3R_311()) {
                    jj_scanpos = xsp;
                    if (jj_3R_312()) return true;
                }
            }
        }
        return false;
    }

    final private boolean jj_3R_303() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_scan_token(86)) {
            jj_scanpos = xsp;
            if (jj_scan_token(122)) {
                jj_scanpos = xsp;
                if (jj_scan_token(92)) {
                    jj_scanpos = xsp;
                    if (jj_scan_token(93)) return true;
                }
            }
        }
        if (jj_3R_302()) return true;
        return false;
    }

    final private boolean jj_3R_301() {
        if (jj_scan_token(INSTANCEOF)) return true;
        if (jj_3R_72()) return true;
        return false;
    }

    final private boolean jj_3R_305() {
        if (jj_3R_307()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_308()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_298() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_scan_token(91)) {
            jj_scanpos = xsp;
            if (jj_scan_token(94)) return true;
        }
        if (jj_3R_297()) return true;
        return false;
    }

    final private boolean jj_3R_304() {
        if (jj_3R_305()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_306()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_302() {
        if (jj_3R_304()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3_22()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_288() {
        if (jj_scan_token(BIT_AND)) return true;
        if (jj_3R_287()) return true;
        return false;
    }

    final private boolean jj_3R_300() {
        if (jj_3R_302()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_303()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_254() {
        if (jj_scan_token(BIT_OR)) return true;
        if (jj_3R_253()) return true;
        return false;
    }

    final private boolean jj_3R_297() {
        if (jj_3R_300()) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_301()) jj_scanpos = xsp;
        return false;
    }

    final private boolean jj_3R_274() {
        if (jj_scan_token(XOR)) return true;
        if (jj_3R_273()) return true;
        return false;
    }

    final private boolean jj_3R_230() {
        if (jj_scan_token(SC_AND)) return true;
        if (jj_3R_229()) return true;
        return false;
    }

    final private boolean jj_3R_287() {
        if (jj_3R_297()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_298()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_190() {
        if (jj_scan_token(SC_OR)) return true;
        if (jj_3R_189()) return true;
        return false;
    }

    final private boolean jj_3R_273() {
        if (jj_3R_287()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_288()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_142() {
        if (jj_scan_token(HOOK)) return true;
        if (jj_3R_56()) return true;
        if (jj_scan_token(COLON)) return true;
        if (jj_3R_56()) return true;
        return false;
    }

    final private boolean jj_3R_253() {
        if (jj_3R_273()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_274()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_229() {
        if (jj_3R_253()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_254()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_189() {
        if (jj_3R_229()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_230()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_141() {
        if (jj_3R_189()) return true;
        Token xsp;
        while (true) {
            xsp = jj_scanpos;
            if (jj_3R_190()) {
                jj_scanpos = xsp;
                break;
            }
        }
        return false;
    }

    final private boolean jj_3R_101() {
        if (jj_3R_141()) return true;
        Token xsp;
        xsp = jj_scanpos;
        if (jj_3R_142()) jj_scanpos = xsp;
        return false;
    }

    final private boolean jj_3R_265() {
        if (jj_3R_90()) return true;
        if (jj_3R_79()) return true;
        if (jj_3R_56()) return true;
        return false;
    }

    final private boolean jj_3R_79() {
        Token xsp;
        xsp = jj_scanpos;
        if (jj_scan_token(85)) {
            jj_scanpos = xsp;
            if (jj_scan_token(110)) {
                jj_scanpos = xsp;
                if (jj_scan_token(111)) {
                    jj_scanpos = xsp;
                    if (jj_scan_token(115)) {
                        jj_scanpos = xsp;
                        if (jj_scan_token(108)) {
                            jj_scanpos = xsp;
                            if (jj_scan_token(109)) {
                                jj_scanpos = xsp;
                                if (jj_scan_token(116)) {
                                    jj_scanpos = xsp;
                                    if (jj_scan_token(117)) {
                                        jj_scanpos = xsp;
                                        if (jj_scan_token(118)) {
                                            jj_scanpos = xsp;
                                            if (jj_scan_token(112)) {
                                                jj_scanpos = xsp;
                                                if (jj_scan_token(114)) {
                                                    jj_scanpos = xsp;
                                                    if (jj_scan_token(113))
                                                        return true;
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        return false;
    }

    final private boolean jj_3_21() {
        if (jj_3R_79()) return true;
        if (jj_3R_56()) return true;
        return false;
    }

    public JavaParserTokenManager token_source;
    JavaCharStream jj_input_stream;
    public Token token, jj_nt;
    private int jj_ntk;
    private Token jj_scanpos, jj_lastpos;
    private int jj_la;
    public boolean lookingAhead = false;
    private boolean jj_semLA;

    public JavaParser(java.io.InputStream stream) {
        this(stream, null);
    }

    public JavaParser(java.io.InputStream stream, String encoding) {
        try {
            jj_input_stream = new JavaCharStream(stream, encoding, 1, 1);
        } catch (java.io.UnsupportedEncodingException e) {
            throw new RuntimeException(e);
        }
        token_source = new JavaParserTokenManager(jj_input_stream);
        token = new Token();
        jj_ntk = -1;
    }

    public void ReInit(java.io.InputStream stream) {
        ReInit(stream, null);
    }

    public void ReInit(java.io.InputStream stream, String encoding) {
        try {
            jj_input_stream.ReInit(stream, encoding, 1, 1);
        } catch (java.io.UnsupportedEncodingException e) {
            throw new RuntimeException(e);
        }
        token_source.ReInit(jj_input_stream);
        token = new Token();
        jj_ntk = -1;
        jjtree.reset();
    }

    public JavaParser(java.io.Reader stream) {
        jj_input_stream = new JavaCharStream(stream, 1, 1);
        token_source = new JavaParserTokenManager(jj_input_stream);
        token = new Token();
        jj_ntk = -1;
    }

    public void ReInit(java.io.Reader stream) {
        jj_input_stream.ReInit(stream, 1, 1);
        token_source.ReInit(jj_input_stream);
        token = new Token();
        jj_ntk = -1;
        jjtree.reset();
    }

    public JavaParser(JavaParserTokenManager tm) {
        token_source = tm;
        token = new Token();
        jj_ntk = -1;
    }

    public void ReInit(JavaParserTokenManager tm) {
        token_source = tm;
        token = new Token();
        jj_ntk = -1;
        jjtree.reset();
    }

    final private Token jj_consume_token(int kind) throws ParseException {
        Token oldToken;
        if ((oldToken = token).next != null) token = token.next;
        else token = token.next = token_source.getNextToken();
        jj_ntk = -1;
        if (token.kind == kind) {
            return token;
        }
        token = oldToken;
        throw generateParseException();
    }

    static private final class LookaheadSuccess extends java.lang.Error {
    }

    final private LookaheadSuccess jj_ls = new LookaheadSuccess();

    final private boolean jj_scan_token(int kind) {
        if (jj_scanpos == jj_lastpos) {
            jj_la--;
            if (jj_scanpos.next == null) {
                jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
            } else {
                jj_lastpos = jj_scanpos = jj_scanpos.next;
            }
        } else {
            jj_scanpos = jj_scanpos.next;
        }
        if (jj_scanpos.kind != kind) return true;
        if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
        return false;
    }

    final public Token getNextToken() {
        if (token.next != null) token = token.next;
        else token = token.next = token_source.getNextToken();
        jj_ntk = -1;
        return token;
    }

    final public Token getToken(int index) {
        Token t = lookingAhead ? jj_scanpos : token;
        for (int i = 0; i < index; i++) {
            if (t.next != null) t = t.next;
            else t = t.next = token_source.getNextToken();
        }
        return t;
    }

    final private int jj_ntk() {
        if ((jj_nt = token.next) == null)
            return (jj_ntk = (token.next = token_source.getNextToken()).kind);
        else
            return (jj_ntk = jj_nt.kind);
    }

    public ParseException generateParseException() {
        Token errortok = token.next;
        int line = errortok.beginLine, column = errortok.beginColumn;
        String mess = (errortok.kind == 0) ? tokenImage[0] : errortok.image;
        return new ParseException("Unable to parse Java code near token: " + mess, line, column);
    }

    final public void enable_tracing() {
    }

    final public void disable_tracing() {
    }

}
